#include "common.h"
#ifndef lint
/*static char yysccsid[] = "from: @(#)yaccpar	1.9 (Berkeley) 02/21/93";*/
static char yyrcsid[]
#if __GNUC__ >= 2
  __attribute__ ((unused))
#endif /* __GNUC__ >= 2 */
  = "$OpenBSD: skeleton.c,v 1.29 2008/07/08 15:06:50 otto Exp $";
#endif
#include <stdlib.h>
#include <string.h>
#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define YYLEX yylex()
#define YYEMPTY -1
#define yyclearin (yychar=(YYEMPTY))
#define yyerrok (yyerrflag=0)
#define YYRECOVERING() (yyerrflag!=0)
#define yyparse socks_yyparse
#define yylex socks_yylex
#define yyerror socks_yyerror
#define yychar socks_yychar
#define yyval socks_yyval
#define yylval socks_yylval
#define yydebug socks_yydebug
#define yynerrs socks_yynerrs
#define yyerrflag socks_yyerrflag
#define yyss socks_yyss
#define yysslim socks_yysslim
#define yyssp socks_yyssp
#define yyvs socks_yyvs
#define yyvsp socks_yyvsp
#define yystacksize socks_yystacksize
#define yylhs socks_yylhs
#define yylen socks_yylen
#define yydefred socks_yydefred
#define yydgoto socks_yydgoto
#define yysindex socks_yysindex
#define yyrindex socks_yyrindex
#define yygindex socks_yygindex
#define yytable socks_yytable
#define yycheck socks_yycheck
#define yyname socks_yyname
#define yyrule socks_yyrule
#define YYPREFIX "socks_yy"
#line 46 "config_parse.y"

#if 0 /* XXX automatically added at head of generated .c file */
#include "common.h"
#endif
#include "ifaddrs_compat.h"
#include "yacconfig.h"

static const char rcsid[] =
"$Id: config_parse.y,v 1.374 2011/03/30 20:01:27 michaels Exp $";

#if HAVE_LIBWRAP && (!SOCKS_CLIENT)
   extern jmp_buf tcpd_buf;
#endif /* HAVE_LIBWRAP && (!SOCKS_CLIENT) */

static void
addrinit(struct ruleaddr_t *addr, const int netmask_required);

static void
gwaddrinit(gwaddr_t *addr);

#if SOCKS_CLIENT
/* parses client environment, if any. */
static void parseclientenv(void);


#else /* !SOCKS_CLIENT */

/*
 * Reset pointers to point away from rule-spesific memory to global
 * memory.  Should be called after adding a rule.
 */
static void rulereset(void);

/*
 * Prepare pointers to point to the correct memory for adding a new rule.
 */
static void ruleinit(struct rule_t *rule);

#endif /* !SOCKS_CLIENT */

extern int yylineno;
extern char *yytext;

static int parsingconfig;

#if !SOCKS_CLIENT
static struct rule_t          rule;          /* new rule.                     */
static struct protocol_t      protocolmem;   /* new protocolmem.              */
static struct timeout_t       *timeout = &sockscf.timeout;
#if !HAVE_PRIVILEGES
static struct userid_t        olduserid;
#endif /* !HAVE_PRIVILEGES */
#endif /* !SOCKS_CLIENT */

static struct serverstate_t   state;
static struct route_t         route;         /* new route.                    */
static gwaddr_t               gw;            /* new gateway.                  */

static struct ruleaddr_t      src;            /* new src.                     */
static struct ruleaddr_t      dst;            /* new dst.                     */
static struct ruleaddr_t      rdr_from;
static struct ruleaddr_t      rdr_to;

#if BAREFOOTD
static struct ruleaddr_t      bounce_to;
#endif /* BAREFOOTD */

static struct ruleaddr_t      *ruleaddr;      /* current ruleaddr             */
static struct extension_t     *extension;     /* new extensions               */
static struct proxyprotocol_t *proxyprotocol; /* proxy protocol.              */

static atype_t                *atype;         /* atype of new address.        */
static struct in_addr         *ipaddr;        /* new ip address               */
static struct in_addr         *netmask;       /* new netmask                  */
static int                    netmask_required;/*
                                                * netmask required for this 
                                                * address?
                                                */
static char                   *domain;        /* new domain.                  */
static char                   *ifname;        /* new ifname.                  */
static char                   *url;           /* new url.                     */

static in_port_t              *port_tcp;      /* new TCP port number.         */
static in_port_t              *port_udp;      /* new UDP port number.         */
static int                    *methodv;       /* new authmethods.             */
static size_t                 *methodc;       /* number of them.              */
static struct protocol_t      *protocol;      /* new protocol.                */
static struct command_t       *command;       /* new command.                 */
static enum operator_t        *operator;      /* new operator.                */

#if HAVE_GSSAPI
static char                  *gssapiservicename; /* new gssapiservice.        */
static char                  *gssapikeytab;      /* new gssapikeytab.         */
static struct gssapi_enc_t   *gssapiencryption;  /* new encryption status.    */
#endif /* HAVE_GSSAPI */

#if HAVE_LDAP
static struct ldap_t         *ldap;        /* new ldap server details.        */
#endif

#if DEBUG
#define YYDEBUG 1
#endif /* DEBUG */

#define ADDMETHOD(method)                                                      \
do {                                                                           \
   if (methodisset(method, methodv, *methodc))                                 \
      yywarn("duplicate method: %s", method2string(method));                   \
   else {                                                                      \
      if (*methodc >= MAXMETHOD)                                               \
         yyerror("internal error, too many authmethods (%ld >= %ld)",          \
         (long)*methodc, (long)MAXMETHOD);                                     \
      methodv[(*methodc)++] = method;                                          \
   }                                                                           \
} while (0)

#line 164 "config_parse.y"
#ifndef YYSTYPE_DEFINED
#define YYSTYPE_DEFINED
typedef union {
   char   *string;
   uid_t   uid;
} YYSTYPE;
#endif /* YYSTYPE_DEFINED */
#line 172 "config_parse.c"
#define SERVERCONFIG 257
#define CLIENTCONFIG 258
#define DEPRECATED 259
#define CLIENTRULE 260
#define INTERNAL 261
#define EXTERNAL 262
#define REALM 263
#define REALNAME 264
#define EXTERNAL_ROTATION 265
#define SAMESAME 266
#define DEBUGGING 267
#define RESOLVEPROTOCOL 268
#define SRCHOST 269
#define NODNSMISMATCH 270
#define NODNSUNKNOWN 271
#define CHECKREPLYAUTH 272
#define EXTENSION 273
#define BIND 274
#define PRIVILEGED 275
#define IOTIMEOUT 276
#define IOTIMEOUT_TCP 277
#define IOTIMEOUT_UDP 278
#define NEGOTIATETIMEOUT 279
#define CONNECTTIMEOUT 280
#define TCP_FIN_WAIT 281
#define METHOD 282
#define CLIENTMETHOD 283
#define NONE 284
#define GSSAPI 285
#define UNAME 286
#define RFC931 287
#define PAM 288
#define BSDAUTH 289
#define COMPATIBILITY 290
#define SAMEPORT 291
#define DRAFT_5_05 292
#define CLIENTCOMPATIBILITY 293
#define NECGSSAPI 294
#define USERNAME 295
#define GROUPNAME 296
#define USER_PRIVILEGED 297
#define USER_UNPRIVILEGED 298
#define USER_LIBWRAP 299
#define LIBWRAP_FILE 300
#define LOGOUTPUT 301
#define LOGFILE 302
#define CHILD_MAXIDLE 303
#define CHILD_MAXREQUESTS 304
#define ROUTE 305
#define VIA 306
#define BADROUTE_EXPIRE 307
#define MAXFAIL 308
#define VERDICT_BLOCK 309
#define VERDICT_PASS 310
#define PAMSERVICENAME 311
#define BSDAUTHSTYLENAME 312
#define BSDAUTHSTYLE 313
#define GSSAPISERVICE 314
#define GSSAPIKEYTAB 315
#define GSSAPIENCTYPE 316
#define GSSAPIENC_ANY 317
#define GSSAPIENC_CLEAR 318
#define GSSAPIENC_INTEGRITY 319
#define GSSAPIENC_CONFIDENTIALITY 320
#define GSSAPIENC_PERMESSAGE 321
#define GSSAPISERVICENAME 322
#define GSSAPIKEYTABNAME 323
#define PROTOCOL 324
#define PROTOCOL_TCP 325
#define PROTOCOL_UDP 326
#define PROTOCOL_FAKE 327
#define PROXYPROTOCOL 328
#define PROXYPROTOCOL_SOCKS_V4 329
#define PROXYPROTOCOL_SOCKS_V5 330
#define PROXYPROTOCOL_HTTP 331
#define PROXYPROTOCOL_UPNP 332
#define USER 333
#define GROUP 334
#define COMMAND 335
#define COMMAND_BIND 336
#define COMMAND_CONNECT 337
#define COMMAND_UDPASSOCIATE 338
#define COMMAND_BINDREPLY 339
#define COMMAND_UDPREPLY 340
#define ACTION 341
#define LINE 342
#define LIBWRAPSTART 343
#define LIBWRAP_ALLOW 344
#define LIBWRAP_DENY 345
#define LIBWRAP_HOSTS_ACCESS 346
#define OPERATOR 347
#define SOCKS_LOG 348
#define SOCKS_LOG_CONNECT 349
#define SOCKS_LOG_DATA 350
#define SOCKS_LOG_DISCONNECT 351
#define SOCKS_LOG_ERROR 352
#define SOCKS_LOG_IOOPERATION 353
#define IPADDRESS 354
#define DOMAINNAME 355
#define DIRECT 356
#define IFNAME 357
#define URL 358
#define PORT 359
#define PORTNUMBER 360
#define SERVICENAME 361
#define NUMBER 362
#define FROM 363
#define TO 364
#define REDIRECT 365
#define BANDWIDTH 366
#define MAXSESSIONS 367
#define UDPPORTRANGE 368
#define UDPCONNECTDST 369
#define YES 370
#define NO 371
#define BOUNCE 372
#define LDAPURL 373
#define LDAP_URL 374
#define LDAPSSL 375
#define LDAPCERTCHECK 376
#define LDAPKEEPREALM 377
#define LDAPBASEDN 378
#define LDAP_BASEDN 379
#define LDAPBASEDN_HEX 380
#define LDAPBASEDN_HEX_ALL 381
#define LDAPSERVER 382
#define LDAPSERVER_NAME 383
#define LDAPGROUP 384
#define LDAPGROUP_NAME 385
#define LDAPGROUP_HEX 386
#define LDAPGROUP_HEX_ALL 387
#define LDAPFILTER 388
#define LDAPFILTER_AD 389
#define LDAPFILTER_HEX 390
#define LDAPFILTER_AD_HEX 391
#define LDAPATTRIBUTE 392
#define LDAPATTRIBUTE_AD 393
#define LDAPATTRIBUTE_HEX 394
#define LDAPATTRIBUTE_AD_HEX 395
#define LDAPCERTFILE 396
#define LDAPCERTPATH 397
#define LDAPPORT 398
#define LDAPPORTSSL 399
#define LDAP_FILTER 400
#define LDAP_ATTRIBUTE 401
#define LDAP_CERTFILE 402
#define LDAP_CERTPATH 403
#define LDAPDOMAIN 404
#define LDAP_DOMAIN 405
#define LDAPTIMEOUT 406
#define LDAPCACHE 407
#define LDAPCACHEPOS 408
#define LDAPCACHENEG 409
#define LDAPKEYTAB 410
#define LDAPKEYTABNAME 411
#define LDAPDEADTIME 412
#define LDAPDEBUG 413
#define LDAPDEPTH 414
#define LDAPAUTO 415
#define LDAPSEARCHTIME 416
#define YYERRCODE 256
#if defined(__cplusplus) || defined(__STDC__)
const short socks_yylhs[] =
#else
short socks_yylhs[] =
#endif
	{                                        -1,
    0,    0,   66,    1,   69,   69,   70,   70,   70,    2,
    2,    2,    2,   35,   36,   36,   68,   68,   67,   67,
   67,   67,   67,   67,   67,   67,   67,   67,   67,   67,
   67,   67,   65,   65,   65,   65,   65,   65,   65,   38,
   38,   38,   38,    3,  115,   29,    7,    8,    8,    8,
    8,    8,    9,    9,   10,   11,   12,   12,   13,   14,
   15,   15,   43,   44,   45,   45,   46,   47,   48,   49,
   50,   50,   50,   37,   37,   37,   37,  114,  114,   51,
   52,   53,   53,   76,   76,   76,   71,   71,   71,   72,
   73,   74,   75,   39,   39,   39,   40,   41,   42,   33,
   81,   81,   82,   83,   84,   84,   85,   85,   54,   55,
   55,   56,   56,   21,   22,   22,   22,   23,   24,   24,
   24,   25,   25,   34,   59,   60,   60,  155,   57,  156,
   58,   61,   61,   61,   61,   61,   61,  123,  124,  124,
  124,  124,  125,  125,  120,  121,  121,  121,  121,  121,
  121,  121,  122,  122,  126,  126,  126,  126,  126,  126,
  126,  126,  126,  126,  126,  126,  126,  126,  126,  126,
  126,  126,  126,  126,  126,  126,  126,  126,  126,  126,
  126,  126,  126,  126,  126,  126,  126,  126,  126,  126,
  126,  126,  126,  126,  126,  126,  110,  110,  101,  111,
  106,  107,   86,   90,   91,   92,  112,  113,   87,   87,
  109,  109,   88,   88,   89,   89,   97,   98,   99,  100,
  102,  103,  104,  105,   95,   96,   94,   93,  108,   62,
   63,   64,   64,  127,  127,   26,   27,   27,   28,   28,
   28,   28,   28,    4,    5,    5,    6,    6,  128,   77,
   77,   77,   79,   80,   78,  129,  131,  131,  131,  131,
  131,  130,  130,   16,   17,   18,   19,   20,  160,  160,
  160,  160,  160,  159,  159,  153,  132,  133,  134,  157,
  158,  117,  118,  118,  118,  118,  118,  118,  118,  118,
  118,  119,  119,  143,  144,  161,  162,  154,  116,  135,
  135,  135,  136,  163,  136,  136,  136,  138,  138,  138,
  138,  138,  137,  145,  145,  139,  140,  141,  142,  146,
  146,  146,  146,  147,  147,  151,  151,  148,  149,  164,
  152,  150,   30,   31,   32,
};
#if defined(__cplusplus) || defined(__STDC__)
const short socks_yylen[] =
#else
short socks_yylen[] =
#endif
	{                                         2,
    2,    2,    1,    2,    0,    2,    1,    1,    1,    0,
    2,    2,    2,    1,    1,    1,    1,    2,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    8,    0,    3,    1,    1,    1,
    1,    1,    1,    2,    3,    1,    1,    2,    3,    1,
    1,    2,    3,    1,    1,    2,    4,    0,    4,    0,
    3,    3,    3,    1,    1,    1,    1,    5,    5,    3,
    1,    1,    2,    3,    3,    3,    1,    1,    1,    3,
    3,    3,    1,    3,    3,    3,    3,    3,    3,    3,
    1,    1,    3,    3,    3,    3,    3,    3,    3,    1,
    1,    1,    2,    3,    1,    1,    1,    3,    1,    1,
    1,    1,    2,    3,    3,    1,    2,    0,    4,    0,
    4,    1,    1,    1,    1,    1,    1,    7,    1,    1,
    1,    1,    0,    2,    6,    1,    1,    1,    1,    1,
    1,    1,    0,    2,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    3,    4,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    1,    1,    2,    1,    1,    3,    1,    2,    1,    1,
    1,    1,    1,    3,    1,    2,    1,    1,    2,    3,
    2,    2,    1,    3,    3,    3,    1,    1,    1,    1,
    1,    1,    2,    3,    3,    3,    3,    3,    1,    1,
    1,    1,    1,    1,    2,    4,    3,    3,    3,    3,
    3,    3,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    0,    2,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    4,    0,    3,    2,    2,    2,    2,    2,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    0,
    3,    3,    2,    0,    3,    1,    1,    3,    1,    1,
    1,    1,    5,    1,    1,
};
#if defined(__cplusplus) || defined(__STDC__)
const short socks_yydefred[] =
#else
short socks_yydefred[] =
#endif
	{                                      0,
    3,   14,    0,   10,    0,    0,   44,   68,   70,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    1,   21,   36,   38,   29,
   37,   39,   41,   42,   40,   43,   34,   22,   23,   24,
   25,   33,   19,   20,   26,   17,    0,   27,   87,   88,
   89,   28,   30,  101,  102,   31,   32,   35,    0,   11,
   16,   77,   74,   12,   15,   75,   76,   13,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  128,  130,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  234,  235,   18,
    4,    0,    9,    8,    7,    0,    0,    0,    0,  124,
   72,   71,   73,  100,  116,  117,  115,  114,  119,  120,
  121,    0,  118,   64,    0,   63,   94,   95,   96,   97,
   98,   99,    0,    0,  110,  111,    0,  109,   93,   90,
   91,   92,   81,    0,   80,   84,   85,   86,    0,    0,
  103,  104,  105,  106,  107,  108,    0,   46,    6,    0,
    0,  313,  316,  317,   67,    0,    0,    0,   69,  300,
  301,  302,  123,   66,  132,  133,  134,  135,  136,  137,
  129,    0,  131,  113,   83,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  150,  151,  192,  193,  159,
  160,  161,  162,  163,  148,  149,  194,  155,  156,  152,
  147,  196,  253,  164,  174,  175,  176,  169,  170,  171,
  190,  187,  188,  189,  177,  179,  181,  183,  166,  178,
  180,  182,  184,  185,  186,  191,  165,  167,  168,  172,
  173,    0,    0,  146,  158,  157,  195,  286,  290,  287,
  288,  289,  283,  285,  291,  284,    0,    0,    0,    0,
    0,  306,  307,  127,   79,   78,  141,  142,  140,    0,
    0,  139,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  296,  297,    0,  252,
    0,    0,    0,    0,    0,  298,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  154,  294,    0,    0,    0,
  293,    0,  315,  314,    0,  305,  332,  329,    0,  323,
    0,    0,  144,    0,  125,  231,    0,  230,  264,  265,
  266,  267,  269,  270,  271,  272,  273,  268,    0,  247,
  248,  244,    0,   48,   49,   50,   51,   52,    0,   47,
   56,    0,   55,   60,    0,   59,  239,  240,  241,  242,
  243,  236,    0,  277,  257,  258,  259,  260,  261,  256,
    0,  250,    0,    0,  255,  254,  334,    0,    0,  203,
  209,  210,  213,  214,  215,  216,  204,  205,  206,  228,
  227,  225,  226,  217,  218,  219,  220,  221,  222,  223,
  224,  201,  202,  207,  208,  199,  229,  197,    0,  200,
  211,  212,    0,  295,  249,    0,    0,  299,    0,    0,
  303,  331,  327,  321,  326,    0,  322,    0,  233,  275,
  246,   54,   58,   62,  238,  263,  280,  281,    0,  276,
  198,  145,    0,  278,    0,    0,  330,  328,  138,  335,
  333,  279,  318,  319,    0,  282,    0,    0,  312,  311,
   45,    0,  308,  309,  310,    0,  325,
};
#if defined(__cplusplus) || defined(__STDC__)
const short socks_yydgoto[] =
#else
short socks_yydgoto[] =
#endif
	{                                       3,
   36,    6,   37,  246,  412,  413,  247,  419,  420,  248,
  422,  423,  249,  425,  426,  250,  251,  252,  253,  254,
   38,  128,   39,  132,  133,  255,  432,  433,  117,  256,
  448,  521,   40,   41,    4,   74,   75,  257,   43,   44,
   45,   46,  304,  135,  136,   48,   79,   49,   80,   50,
   51,  154,  155,   52,  147,  148,   53,   54,  258,  191,
  192,  259,  397,  398,   55,    5,   56,   57,  111,  112,
   58,   59,   60,   61,  150,   62,  260,  261,  262,  263,
   63,   64,   65,   66,   67,  264,  265,  266,  267,  268,
  269,  270,  271,  272,  273,  274,  275,  276,  277,  278,
  279,  280,  281,  282,  283,  284,  285,  286,  287,  288,
  289,  290,  291,   68,  113,  489,  490,  307,  308,  114,
  292,  293,  115,  320,  321,  294,  116,  378,  295,  440,
  441,  296,  379,  485,  179,  175,  176,  526,  177,  178,
  529,  530,  380,  486,  385,  312,  533,  390,  493,  392,
  494,  495,  297,  347,  143,  144,  339,  340,  408,  409,
  341,  342,  310,  518,
};
#if defined(__cplusplus) || defined(__STDC__)
const short socks_yysindex[] =
#else
short socks_yysindex[] =
#endif
	{                                   -206,
    0,    0,    0,    0, -170,  167,    0,    0,    0,  -26,
  -23,  -15,   -9,    8,   10,   12,   30,   32,   36,   47,
   61,   72,   74,   78,   89,  107,  114,  122,  125,  127,
  185,  177,  179,  183,  184,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, -223,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  185,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  192,  193,
  -12, -236, -103, -209,  -43,   -7,  -97,  -91,  -90,  -89,
  -87,  -86,    0,    0, -207,   -8,   -8,   -8,  -16, -246,
  -74, -151,  -11,  -10, -218, -212, -148,    0,    0,    0,
    0, -123,    0,    0,    0,  169,  170, -253, -253,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  -43,    0,    0,   -7,    0,    0,    0,    0,    0,
    0,    0,  -93,  -93,    0,    0, -207,    0,    0,    0,
    0,    0,    0,  -16,    0,    0,    0,    0,  237,  238,
    0,    0,    0,    0,    0,    0,  174,    0,    0, 2041,
  -92,    0,    0,    0,    0,  254,  -56,  -56,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  -93,    0,    0,    0,  -54,  -53, 2181,  260,  262,
  266,  280,  281,  282,  283,  284,  285,  290,  292,  293,
  294,  295, -193,  296,  297,  298,   -6,  299,  301,  303,
  304,  305,  313,  314,  317,  322,  326,  328,  343,  348,
  349,  350,  351,  352,  354,  355,  359,  366,  372,  373,
  374,  387,  388,  389,  390,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 2041,   86,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  -92,   86, -321,  -56,
  -34,    0,    0,    0,    0,    0,    0,    0,    0, 2181,
   86,    0,  -93,  157,   91,  142,  133,  137, -256, -147,
 -163,  161,  166, -128,  135, -105,    0,    0,  103,    0,
  421,  422,  119,  120,  123,    0,  427,  112, -182, -173,
 -150,  108,  110,  111,  109,  106,  113,  115,   96,   97,
   99,  101,  116,  117,  118,  121,  100,  104,  147,  148,
  126,  102,  -35,  149, -137,    0,    0, 2041,  150,  454,
    0,  209,    0,    0,  -56,    0,    0,    0, -121,    0,
  471, -121,    0, 2181,    0,    0,  157,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, -256,    0,
    0,    0, -147,    0,    0,    0,    0,    0, -163,    0,
    0,  161,    0,    0,  166,    0,    0,    0,    0,    0,
    0,    0, -128,    0,    0,    0,    0,    0,    0,    0,
 -105,    0, -253, -253,    0,    0,    0,  475, -253,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  159,    0,
    0,    0,  405,    0,    0,  476, -253,    0,  481,  -92,
    0,    0,    0,    0,    0,  200,    0,  418,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  201,    0,
    0,    0, -253,    0, -100,  420,    0,    0,    0,    0,
    0,    0,    0,    0,  203,    0,  203,  203,    0,    0,
    0,  216,    0,    0,    0, -121,    0,};
#if defined(__cplusplus) || defined(__STDC__)
const short socks_yyrindex[] =
#else
short socks_yyrindex[] =
#endif
	{                                      0,
    0,    0,    0,    0,    0,  565,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  566,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  444,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  566,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  636,    0,    0,  478,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  730,    0,    0,    0,
    0,    0,    0,  583,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  205,
  206,    0,    0,    0,    0,    1,  160,  160,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  319,    0,    0,    0,    0,    0,  208,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, -125,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, -114,    0,    0,  160,
    0,    0,    0,    0,    0,    0,    0,    0,    0, -110,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1481,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  447,    0,    0,
    0,    0,    0,    0,  160,    0,    0,    0,    0,    0,
    0,    0,    0,  451,    0,    0,  769,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  912,    0,
    0,    0, 1055,    0,    0,    0,    0,    0, 1198,    0,
    0, 1621,    0,    0, 1761,    0,    0,    0,    0,    0,
    0,    0, 1341,    0,    0,    0,    0,    0,    0,    0,
 1901,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  452,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, -109,    0, -109, -109,    0,    0,
    0,    0,    0,    0,    0,    0,    0,};
#if defined(__cplusplus) || defined(__STDC__)
const short socks_yygindex[] =
#else
short socks_yygindex[] =
#endif
	{                                      0,
    0,    0,   -1, -169,  172,    0, -168,    0,  171,    0,
    0,  182,    0,    0,  164,    0,    0, -167, -162, -159,
  585,    0,    0,    0,  462, -158,  173,    0,    0,    0,
    0,    0,  599,    0,    0,    0,    0,   22,    0,    0,
    0,    0,   26,    0,  472,    0,    0,    0,    0,    0,
  602,    0,  456,    0,    0,  464,    0,    0, -157, -119,
    0, -153,    0,  217,    0,    0,  556,    0,  503,    0,
    0,    0,    0,    0,  105,    0, -178, -177,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  613,  615,    0,    0,    0, -290,    0,
    0, -264,    0,    0, -294, -176,  518, -274,    0,  186,
    0,    0,    0,    0,    0, -372, -113,    0, -112, -111,
    0,    0,    0,    0,    0, -155, -314,    0,  315,  124,
 -373,    0,    0,    0,    0,    0,    0,  300,  222,    0,
    0,    0,    0,    0,
};
#define YYTABLESIZE 2596
#if defined(__cplusplus) || defined(__STDC__)
const short socks_yytable[] =
#else
short socks_yytable[] =
#endif
	{                                     153,
  304,  298,  299,  300,   71,  180,  181,  182,  301,  479,
  292,  302,  303,  305,  143,  324,  381,  306,  497,  318,
  319,  322,  313,  389,  193,  393,   42,  376,  317,  121,
   47,   81,  383,  382,   82,    7,  107,    8,    9,   10,
  384,   11,   83,   12,   13,   14,  394,  122,   84,   15,
    1,    2,   16,   17,   18,   19,   20,   21,   22,   23,
  403,  404,  405,  406,  407,   85,   24,   86,  123,   87,
  507,  508,  314,   25,   26,   27,  510,   28,   42,   29,
   30,   69,   47,  145,  146,  108,  109,   88,    7,   89,
    8,    9,   10,   90,   11,    7,   12,   13,   14,  498,
  172,  173,   15,  174,   91,   16,   17,   18,   19,   20,
   21,   22,   23,  483,  514,  125,  126,  127,   92,   24,
   32,   33,   34,  156,  157,  304,   25,   26,   27,   93,
   28,   94,   29,   30,   31,   95,  107,  298,  299,  300,
  522,  318,  319,  322,  301,   35,   96,  302,  303,  305,
  317,  163,  164,  306,  386,  159,  160,  165,  166,  320,
  108,  109,  537,  324,   97,  414,  415,  416,  417,  337,
  338,   98,  324,   32,   33,   34,   70,  410,  411,   99,
   15,  168,  100,  324,  101,  108,  109,  451,  452,  199,
  185,  186,  187,  188,  189,  190,  453,  454,   35,  516,
  200,  151,  152,  395,  324,  324,  324,  427,  428,  429,
  430,  431,  534,  535,  324,  318,  319,  322,  324,  455,
  456,  203,  204,  205,  317,  324,  129,  130,  131,  491,
  102,  206,  481,  482,  103,  207,  104,  153,  388,  492,
  105,  106,  210,  435,  436,  437,  438,  439,  292,  118,
  119,  120,  143,  172,  173,  523,  174,  524,  124,  304,
  304,  304,  304,  304,  137,  304,  134,  304,  304,  304,
  138,  139,  140,  304,  141,  142,  304,  304,  304,  304,
  304,  304,  304,  304,  320,  153,  149,  158,  161,  162,
  304,  170,  171,  304,  196,  197,  198,  304,  304,  304,
  309,  304,  311,  304,  304,  304,  304,  315,  316,  304,
  304,  304,  387,  304,  304,  304,  304,  323,  126,  324,
  298,  299,  300,  325,  304,  388,  478,  301,  304,  418,
  302,  303,  305,  304,  304,  304,  306,  326,  327,  328,
  329,  330,  331,  304,  304,  304,  304,  332,  304,  333,
  334,  335,  336,  343,  344,  345,  348,  346,  349,  304,
  350,  351,  352,  304,  304,  304,  304,  304,  304,  304,
  353,  354,  304,  304,  355,  304,  304,  304,  304,  356,
  304,  304,  304,  357,  304,  358,  304,  304,  304,  304,
  304,  304,  304,  304,  304,  304,  304,  304,  304,  304,
  359,  525,  527,  528,  304,  360,  361,  362,  363,  364,
  304,  365,  366,  304,  304,  304,  367,  418,  320,  320,
  320,  320,  320,  368,  320,    7,  320,  320,  320,  369,
  370,  371,  320,   12,   13,  320,  320,  320,  320,  320,
  320,  320,  320,  126,  372,  373,  374,  375,  377,  320,
  396,  399,  320,  400,  401,  421,  320,  320,  320,  402,
  320,  424,  320,  320,  320,  320,  338,   28,  320,  320,
  320,   69,  320,  320,  320,  320,  434,   65,  443,  444,
  445,  446,  447,  320,  449,  450,  457,  320,  458,  459,
  461,  460,  320,  320,  320,  464,  465,  462,  466,  463,
  467,  472,  320,  320,  320,  320,  473,  320,  474,  475,
  480,  487,  477,  484,  488,  496,  468,  469,  470,  509,
  511,  471,  320,  320,  320,  320,  320,  320,  320,  512,
  476,  320,  320,  513,  320,  320,  320,  320,  515,  320,
  320,  320,  519,  320,  531,  320,  320,  320,  320,  320,
  320,  320,  320,  320,  320,  320,  320,  320,  320,  517,
  520,  532,  387,  320,    2,    5,   46,  153,  292,  320,
  143,  153,  320,  320,  320,  143,  292,  126,  126,  126,
  126,  126,   82,  126,  501,  126,  126,  126,  504,  502,
   72,  126,   82,  183,  126,  126,  126,  126,  126,  126,
  126,  126,   65,  503,   73,  505,  184,   76,  126,  195,
  194,  126,  110,  499,  169,  126,  126,  126,   77,  126,
   78,  126,  126,  126,  167,  391,  506,  126,  126,  126,
  500,  126,  126,  126,  126,  122,    0,    0,  442,    0,
    0,    0,  126,    0,    0,    0,  126,    0,    0,    0,
    0,  126,  126,  126,    0,  536,    0,    0,    0,    0,
    0,  126,  126,  126,  126,    0,  126,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  126,    0,  126,  126,  126,  126,  126,    0,    0,
  126,  126,    0,  126,  126,  126,  126,    0,  126,  126,
  126,    0,  126,    0,  126,  126,  126,  126,  126,  126,
  126,  126,  126,  126,  126,  126,  126,  126,    0,    0,
    0,    0,  126,    0,    0,    0,    0,    0,  126,  112,
    0,  126,  126,  126,    0,    0,   65,   65,   65,   65,
   65,    0,   65,    0,   65,   65,   65,    0,    0,    0,
   65,    0,    0,   65,   65,   65,   65,   65,   65,   65,
   65,    0,    0,    0,    0,    0,    0,   65,    0,    0,
   65,    0,    0,    0,   65,   65,   65,    0,   65,    0,
   65,   65,   65,    0,    0,    0,   65,   65,    0,    0,
    0,   65,   65,   65,    0,    0,    0,    0,    0,    0,
    0,   65,    0,    0,    0,   65,    0,    0,    0,    0,
    0,    0,   65,    0,    0,    0,    0,    0,    0,    0,
    0,   65,   65,   65,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   65,   82,   82,   82,   82,   82,   65,   82,    0,   82,
   82,   82,    0,    0,    0,   82,    0,    0,   82,   82,
   82,   82,   82,   82,   82,   82,    0,    0,    0,    0,
    0,    0,   82,    0,    0,    0,    0,    0,    0,   82,
   82,   82,    0,   82,    0,   82,   82,   82,    0,    0,
    0,   82,   82,  232,  122,  122,  122,  122,  122,    0,
  122,    0,  122,  122,  122,    0,    0,    0,  122,    0,
    0,  122,  122,  122,  122,  122,  122,  122,  122,    0,
    0,    0,    0,    0,    0,  122,   82,   82,   82,    0,
    0,    0,  122,  122,  122,    0,  122,    0,  122,  122,
  122,    0,    0,    0,  122,  122,    0,    0,    0,    0,
    0,   82,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  122,
  122,  122,    0,    0,    0,    0,    0,    0,  112,  112,
  112,  112,  112,    0,  112,    0,  112,  112,  112,    0,
    0,    0,  112,    0,  122,  112,  112,  112,  112,  112,
  112,  112,  112,    0,    0,    0,    0,    0,    0,  112,
    0,    0,    0,    0,    0,    0,  112,  112,  112,    0,
  112,    0,  112,  112,  112,    0,  274,    0,  112,  112,
    0,  232,    0,    0,  232,  232,  232,  232,  232,  232,
  232,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  232,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  112,  112,  112,    0,    0,    0,  232,
    0,  232,  232,  232,  232,    0,    0,    0,    0,    0,
    0,    0,  232,    0,    0,    0,  232,    0,  112,    0,
    0,  232,  232,  232,    0,    0,    0,    0,    0,    0,
    0,  232,    0,    0,    0,    0,  232,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  232,    0,  232,  232,  232,  232,    0,    0,    0,
  232,  232,    0,  232,  232,  232,  232,    0,  232,  232,
  232,    0,  232,    0,  232,  232,  232,  232,  232,  232,
  232,  232,  232,  232,  232,  232,  232,  232,    0,    0,
    0,    0,  232,    0,    0,    0,    0,    0,  232,  245,
    0,  232,  232,  232,  274,    0,    0,  274,  274,  274,
  274,  274,  274,  274,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  274,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  274,    0,  274,  274,  274,  274,    0,    0,
    0,    0,    0,    0,    0,  274,    0,    0,    0,  274,
    0,    0,    0,    0,  274,  274,  274,    0,    0,    0,
    0,    0,    0,    0,  274,    0,    0,    0,    0,  274,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  274,    0,  274,  274,  274,  274,
    0,    0,    0,  274,  274,    0,  274,  274,  274,  274,
    0,  274,  274,  274,    0,  274,    0,  274,  274,  274,
  274,  274,  274,  274,  274,  274,  274,  274,  274,  274,
  274,    0,    0,    0,    0,  274,    0,    0,    0,    0,
    0,  274,   53,    0,  274,  274,  274,  245,    0,    0,
  245,  245,  245,  245,  245,  245,  245,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  245,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  245,    0,  245,  245,  245,
  245,    0,    0,    0,    0,    0,    0,    0,  245,    0,
    0,    0,  245,    0,    0,    0,    0,  245,  245,  245,
    0,    0,    0,    0,    0,    0,    0,  245,    0,    0,
    0,    0,  245,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  245,    0,  245,
  245,  245,  245,    0,    0,    0,  245,  245,    0,  245,
  245,  245,  245,    0,  245,  245,  245,    0,  245,    0,
  245,  245,  245,  245,  245,  245,  245,  245,  245,  245,
  245,  245,  245,  245,    0,    0,    0,    0,  245,    0,
    0,    0,    0,    0,  245,  237,    0,  245,  245,  245,
   53,    0,    0,   53,   53,   53,   53,   53,   53,   53,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   53,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   53,    0,
   53,   53,   53,   53,    0,    0,    0,    0,    0,    0,
    0,   53,    0,    0,    0,   53,    0,    0,    0,    0,
   53,   53,   53,    0,    0,    0,    0,    0,    0,    0,
   53,    0,    0,    0,    0,   53,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   53,    0,   53,   53,   53,   53,    0,    0,    0,   53,
   53,    0,   53,   53,   53,   53,    0,   53,   53,   53,
    0,   53,    0,   53,   53,   53,   53,   53,   53,   53,
   53,   53,   53,   53,   53,   53,   53,    0,    0,    0,
    0,   53,    0,    0,    0,  251,    0,   53,    0,    0,
   53,   53,   53,  237,    0,    0,  237,  237,  237,  237,
  237,  237,  237,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  237,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  237,    0,  237,  237,  237,  237,    0,    0,    0,
    0,    0,    0,    0,  237,    0,    0,    0,  237,    0,
    0,    0,    0,  237,  237,  237,    0,    0,    0,    0,
    0,    0,    0,  237,    0,    0,    0,    0,  237,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  237,    0,  237,  237,  237,  237,    0,
    0,    0,  237,  237,    0,  237,  237,  237,  237,    0,
  237,  237,  237,    0,  237,    0,  237,  237,  237,  237,
  237,  237,  237,  237,  237,  237,  237,  237,  237,  237,
    0,    0,    0,    0,  237,   57,    0,    0,    0,    0,
  237,    0,    0,  237,  237,  237,  251,  251,  251,  251,
  251,  251,  251,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  251,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  251,    0,  251,  251,  251,  251,    0,    0,    0,
    0,    0,    0,    0,  251,    0,    0,    0,  251,    0,
    0,    0,    0,  251,  251,  251,    0,    0,    0,    0,
    0,    0,    0,  251,    0,    0,    0,    0,  251,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  251,    0,  251,  251,  251,  251,    0,
    0,    0,  251,  251,    0,  251,  251,  251,  251,    0,
  251,  251,  251,    0,  251,    0,  251,  251,  251,  251,
  251,  251,  251,  251,  251,  251,  251,  251,  251,  251,
    0,    0,    0,    0,  251,   61,    0,    0,    0,    0,
  251,    0,    0,  251,  251,  251,   57,   57,   57,   57,
   57,   57,   57,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   57,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   57,    0,   57,   57,   57,   57,    0,    0,    0,
    0,    0,    0,    0,   57,    0,    0,    0,   57,    0,
    0,    0,    0,   57,   57,   57,    0,    0,    0,    0,
    0,    0,    0,   57,    0,    0,    0,    0,   57,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   57,    0,   57,   57,   57,   57,    0,
    0,    0,   57,   57,    0,   57,   57,   57,   57,    0,
   57,   57,   57,    0,   57,    0,   57,   57,   57,   57,
   57,   57,   57,   57,   57,   57,   57,   57,   57,   57,
    0,    0,    0,    0,   57,  262,    0,    0,    0,    0,
   57,    0,    0,   57,   57,   57,   61,   61,   61,   61,
   61,   61,   61,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   61,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   61,    0,   61,   61,   61,   61,    0,    0,    0,
    0,    0,    0,    0,   61,    0,    0,    0,   61,    0,
    0,    0,    0,   61,   61,   61,    0,    0,    0,    0,
    0,    0,    0,   61,    0,    0,    0,    0,   61,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   61,    0,   61,   61,   61,   61,    0,
    0,    0,   61,   61,    0,   61,   61,   61,   61,    0,
   61,   61,   61,    0,   61,    0,   61,   61,   61,   61,
   61,   61,   61,   61,   61,   61,   61,   61,   61,   61,
    0,    0,    0,    0,   61,    0,    0,    0,    0,    0,
   61,    0,    0,   61,   61,   61,  262,  262,  262,  262,
  262,  262,  262,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  262,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  262,    0,  262,  262,  262,  262,    0,    0,    0,
    0,    0,    0,    0,  262,    0,    0,    0,  262,    0,
    0,    0,    0,  262,  262,  262,    0,    0,    0,    0,
    0,    0,    0,  262,    0,    0,    0,    0,  262,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  262,    0,  262,  262,  262,  262,    0,
    0,    0,  262,  262,    0,  262,  262,  262,  262,    0,
  262,  262,  262,    0,  262,    0,  262,  262,  262,  262,
  262,  262,  262,  262,  262,  262,  262,  262,  262,  262,
    0,    0,    0,    0,  262,    0,    0,    0,    0,    0,
  262,    0,    0,  262,  262,  262,   16,   17,   18,   19,
   20,   21,  199,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  200,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  201,    0,  202,  203,  204,  205,    0,    0,    0,
    0,    0,    0,    0,  206,    0,    0,    0,  207,    0,
    0,    0,    0,  208,  209,  210,    0,    0,    0,    0,
    0,    0,    0,  211,    0,    0,    0,    0,  212,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  213,  214,  215,  216,    0,
    0,    0,  217,  218,    0,  219,  220,  221,  222,    0,
  223,  224,  225,    0,  226,    0,  227,  228,  229,  230,
  231,  232,  233,  234,  235,  236,  237,  238,  239,  240,
    0,    0,    0,    0,  241,    0,    0,    0,    0,    0,
  242,    0,    0,  243,  244,  245,   16,   17,   18,   19,
   20,   21,  199,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  200,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  201,    0,  202,  203,  204,  205,    0,    0,    0,
    0,    0,    0,    0,  206,    0,    0,    0,    0,    0,
    0,    0,    0,  208,  209,    0,    0,    0,    0,    0,
    0,    0,    0,  211,    0,    0,    0,    0,  212,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  213,  214,  215,    0,    0,
    0,    0,  217,  218,    0,  219,  220,  221,  222,    0,
  223,  224,  225,    0,  226,    0,  227,  228,  229,  230,
  231,  232,  233,  234,  235,  236,  237,  238,  239,  240,
    0,    0,    0,    0,  241,    0,    0,    0,    0,    0,
  242,    0,    0,  243,  244,  245,
};
#if defined(__cplusplus) || defined(__STDC__)
const short socks_yycheck[] =
#else
short socks_yycheck[] =
#endif
	{                                     125,
    0,  171,  171,  171,    6,  119,  119,  119,  171,   45,
  125,  171,  171,  171,  125,  125,  307,  171,  392,  198,
  198,  198,  178,   58,  144,  320,    5,  292,  198,  266,
    5,   58,  354,  308,   58,  259,  260,  261,  262,  263,
  362,  265,   58,  267,  268,  269,  321,  284,   58,  273,
  257,  258,  276,  277,  278,  279,  280,  281,  282,  283,
  317,  318,  319,  320,  321,   58,  290,   58,  305,   58,
  443,  444,  192,  297,  298,  299,  449,  301,   57,  303,
  304,  305,   57,  291,  292,  309,  310,   58,  259,   58,
  261,  262,  263,   58,  265,  259,  267,  268,  269,  394,
  354,  355,  273,  357,   58,  276,  277,  278,  279,  280,
  281,  282,  283,  378,  487,  325,  326,  327,   58,  290,
  344,  345,  346,  370,  371,  125,  297,  298,  299,   58,
  301,   58,  303,  304,  305,   58,  260,  307,  307,  307,
  513,  320,  320,  320,  307,  369,   58,  307,  307,  307,
  320,  370,  371,  307,  310,  307,  308,  370,  371,    0,
  309,  310,  536,  273,   58,  329,  330,  331,  332,  363,
  364,   58,  282,  344,  345,  346,   10,  325,  326,   58,
  273,  305,   58,  293,   58,  309,  310,  370,  371,  282,
  284,  285,  286,  287,  288,  289,  370,  371,  369,  490,
  293,   97,   98,  323,  314,  315,  316,  336,  337,  338,
  339,  340,  527,  528,  324,  394,  394,  394,  328,  370,
  371,  314,  315,  316,  394,  335,  270,  271,  272,  385,
   46,  324,  370,  371,   58,  328,   58,  363,  360,  361,
   58,   58,  335,  349,  350,  351,  352,  353,  363,   58,
   58,  264,  363,  354,  355,  356,  357,  358,  362,  259,
  260,  261,  262,  263,  362,  265,  274,  267,  268,  269,
  362,  362,  362,  273,  362,  362,  276,  277,  278,  279,
  280,  281,  282,  283,  125,  302,  295,  362,  300,  300,
  290,  123,  123,  293,   58,   58,  123,  297,  298,  299,
   47,  301,  359,  303,  304,  305,  306,  362,  362,  309,
  310,  311,  347,  313,  314,  315,  316,   58,    0,   58,
  490,  490,  490,   58,  324,  360,  362,  490,  328,  331,
  490,  490,  490,  333,  334,  335,  490,   58,   58,   58,
   58,   58,   58,  343,  344,  345,  346,   58,  348,   58,
   58,   58,   58,   58,   58,   58,   58,  364,   58,  359,
   58,   58,   58,  363,  364,  365,  366,  367,  368,  369,
   58,   58,  372,  373,   58,  375,  376,  377,  378,   58,
  380,  381,  382,   58,  384,   58,  386,  387,  388,  389,
  390,  391,  392,  393,  394,  395,  396,  397,  398,  399,
   58,  515,  515,  515,  404,   58,   58,   58,   58,   58,
  410,   58,   58,  413,  414,  415,   58,  419,  259,  260,
  261,  262,  263,   58,  265,  259,  267,  268,  269,   58,
   58,   58,  273,  267,  268,  276,  277,  278,  279,  280,
  281,  282,  283,  125,   58,   58,   58,   58,  363,  290,
  294,  361,  293,  312,  322,  295,  297,  298,  299,  323,
  301,  296,  303,  304,  305,  306,  364,  301,  309,  310,
  311,  305,  313,  314,  315,  316,  342,    0,   58,   58,
  362,  362,  360,  324,   58,  374,  379,  328,  379,  379,
  385,  383,  333,  334,  335,  400,  400,  385,  400,  385,
  400,  402,  343,  344,  345,  346,  403,  348,  362,  362,
  362,   58,  411,  364,  306,   45,  401,  401,  401,   45,
  362,  401,  363,  364,  365,  366,  367,  368,  369,  125,
  405,  372,  373,   58,  375,  376,  377,  378,   58,  380,
  381,  382,  125,  384,  125,  386,  387,  388,  389,  390,
  391,  392,  393,  394,  395,  396,  397,  398,  399,  360,
  360,  359,  347,  404,    0,    0,  123,  363,  363,  410,
  363,  125,  413,  414,  415,  125,  125,  259,  260,  261,
  262,  263,    0,  265,  413,  267,  268,  269,  425,  419,
    6,  273,   10,  132,  276,  277,  278,  279,  280,  281,
  282,  283,  125,  422,    6,  433,  135,    6,  290,  154,
  147,  293,   57,  397,  112,  297,  298,  299,    6,  301,
    6,  303,  304,  305,  107,  311,  441,  309,  310,  311,
  409,  313,  314,  315,  316,    0,   -1,   -1,  339,   -1,
   -1,   -1,  324,   -1,   -1,   -1,  328,   -1,   -1,   -1,
   -1,  333,  334,  335,   -1,  532,   -1,   -1,   -1,   -1,
   -1,  343,  344,  345,  346,   -1,  348,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  363,   -1,  365,  366,  367,  368,  369,   -1,   -1,
  372,  373,   -1,  375,  376,  377,  378,   -1,  380,  381,
  382,   -1,  384,   -1,  386,  387,  388,  389,  390,  391,
  392,  393,  394,  395,  396,  397,  398,  399,   -1,   -1,
   -1,   -1,  404,   -1,   -1,   -1,   -1,   -1,  410,    0,
   -1,  413,  414,  415,   -1,   -1,  259,  260,  261,  262,
  263,   -1,  265,   -1,  267,  268,  269,   -1,   -1,   -1,
  273,   -1,   -1,  276,  277,  278,  279,  280,  281,  282,
  283,   -1,   -1,   -1,   -1,   -1,   -1,  290,   -1,   -1,
  293,   -1,   -1,   -1,  297,  298,  299,   -1,  301,   -1,
  303,  304,  305,   -1,   -1,   -1,  309,  310,   -1,   -1,
   -1,  314,  315,  316,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  324,   -1,   -1,   -1,  328,   -1,   -1,   -1,   -1,
   -1,   -1,  335,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  344,  345,  346,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  363,  259,  260,  261,  262,  263,  369,  265,   -1,  267,
  268,  269,   -1,   -1,   -1,  273,   -1,   -1,  276,  277,
  278,  279,  280,  281,  282,  283,   -1,   -1,   -1,   -1,
   -1,   -1,  290,   -1,   -1,   -1,   -1,   -1,   -1,  297,
  298,  299,   -1,  301,   -1,  303,  304,  305,   -1,   -1,
   -1,  309,  310,  125,  259,  260,  261,  262,  263,   -1,
  265,   -1,  267,  268,  269,   -1,   -1,   -1,  273,   -1,
   -1,  276,  277,  278,  279,  280,  281,  282,  283,   -1,
   -1,   -1,   -1,   -1,   -1,  290,  344,  345,  346,   -1,
   -1,   -1,  297,  298,  299,   -1,  301,   -1,  303,  304,
  305,   -1,   -1,   -1,  309,  310,   -1,   -1,   -1,   -1,
   -1,  369,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  344,
  345,  346,   -1,   -1,   -1,   -1,   -1,   -1,  259,  260,
  261,  262,  263,   -1,  265,   -1,  267,  268,  269,   -1,
   -1,   -1,  273,   -1,  369,  276,  277,  278,  279,  280,
  281,  282,  283,   -1,   -1,   -1,   -1,   -1,   -1,  290,
   -1,   -1,   -1,   -1,   -1,   -1,  297,  298,  299,   -1,
  301,   -1,  303,  304,  305,   -1,  125,   -1,  309,  310,
   -1,  273,   -1,   -1,  276,  277,  278,  279,  280,  281,
  282,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  293,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  344,  345,  346,   -1,   -1,   -1,  311,
   -1,  313,  314,  315,  316,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  324,   -1,   -1,   -1,  328,   -1,  369,   -1,
   -1,  333,  334,  335,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  343,   -1,   -1,   -1,   -1,  348,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  363,   -1,  365,  366,  367,  368,   -1,   -1,   -1,
  372,  373,   -1,  375,  376,  377,  378,   -1,  380,  381,
  382,   -1,  384,   -1,  386,  387,  388,  389,  390,  391,
  392,  393,  394,  395,  396,  397,  398,  399,   -1,   -1,
   -1,   -1,  404,   -1,   -1,   -1,   -1,   -1,  410,  125,
   -1,  413,  414,  415,  273,   -1,   -1,  276,  277,  278,
  279,  280,  281,  282,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  293,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  311,   -1,  313,  314,  315,  316,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  324,   -1,   -1,   -1,  328,
   -1,   -1,   -1,   -1,  333,  334,  335,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  343,   -1,   -1,   -1,   -1,  348,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  363,   -1,  365,  366,  367,  368,
   -1,   -1,   -1,  372,  373,   -1,  375,  376,  377,  378,
   -1,  380,  381,  382,   -1,  384,   -1,  386,  387,  388,
  389,  390,  391,  392,  393,  394,  395,  396,  397,  398,
  399,   -1,   -1,   -1,   -1,  404,   -1,   -1,   -1,   -1,
   -1,  410,  125,   -1,  413,  414,  415,  273,   -1,   -1,
  276,  277,  278,  279,  280,  281,  282,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  293,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  311,   -1,  313,  314,  315,
  316,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  324,   -1,
   -1,   -1,  328,   -1,   -1,   -1,   -1,  333,  334,  335,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  343,   -1,   -1,
   -1,   -1,  348,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  363,   -1,  365,
  366,  367,  368,   -1,   -1,   -1,  372,  373,   -1,  375,
  376,  377,  378,   -1,  380,  381,  382,   -1,  384,   -1,
  386,  387,  388,  389,  390,  391,  392,  393,  394,  395,
  396,  397,  398,  399,   -1,   -1,   -1,   -1,  404,   -1,
   -1,   -1,   -1,   -1,  410,  125,   -1,  413,  414,  415,
  273,   -1,   -1,  276,  277,  278,  279,  280,  281,  282,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  293,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  311,   -1,
  313,  314,  315,  316,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  324,   -1,   -1,   -1,  328,   -1,   -1,   -1,   -1,
  333,  334,  335,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  343,   -1,   -1,   -1,   -1,  348,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  363,   -1,  365,  366,  367,  368,   -1,   -1,   -1,  372,
  373,   -1,  375,  376,  377,  378,   -1,  380,  381,  382,
   -1,  384,   -1,  386,  387,  388,  389,  390,  391,  392,
  393,  394,  395,  396,  397,  398,  399,   -1,   -1,   -1,
   -1,  404,   -1,   -1,   -1,  125,   -1,  410,   -1,   -1,
  413,  414,  415,  273,   -1,   -1,  276,  277,  278,  279,
  280,  281,  282,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  293,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  311,   -1,  313,  314,  315,  316,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  324,   -1,   -1,   -1,  328,   -1,
   -1,   -1,   -1,  333,  334,  335,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  343,   -1,   -1,   -1,   -1,  348,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  363,   -1,  365,  366,  367,  368,   -1,
   -1,   -1,  372,  373,   -1,  375,  376,  377,  378,   -1,
  380,  381,  382,   -1,  384,   -1,  386,  387,  388,  389,
  390,  391,  392,  393,  394,  395,  396,  397,  398,  399,
   -1,   -1,   -1,   -1,  404,  125,   -1,   -1,   -1,   -1,
  410,   -1,   -1,  413,  414,  415,  276,  277,  278,  279,
  280,  281,  282,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  293,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  311,   -1,  313,  314,  315,  316,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  324,   -1,   -1,   -1,  328,   -1,
   -1,   -1,   -1,  333,  334,  335,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  343,   -1,   -1,   -1,   -1,  348,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  363,   -1,  365,  366,  367,  368,   -1,
   -1,   -1,  372,  373,   -1,  375,  376,  377,  378,   -1,
  380,  381,  382,   -1,  384,   -1,  386,  387,  388,  389,
  390,  391,  392,  393,  394,  395,  396,  397,  398,  399,
   -1,   -1,   -1,   -1,  404,  125,   -1,   -1,   -1,   -1,
  410,   -1,   -1,  413,  414,  415,  276,  277,  278,  279,
  280,  281,  282,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  293,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  311,   -1,  313,  314,  315,  316,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  324,   -1,   -1,   -1,  328,   -1,
   -1,   -1,   -1,  333,  334,  335,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  343,   -1,   -1,   -1,   -1,  348,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  363,   -1,  365,  366,  367,  368,   -1,
   -1,   -1,  372,  373,   -1,  375,  376,  377,  378,   -1,
  380,  381,  382,   -1,  384,   -1,  386,  387,  388,  389,
  390,  391,  392,  393,  394,  395,  396,  397,  398,  399,
   -1,   -1,   -1,   -1,  404,  125,   -1,   -1,   -1,   -1,
  410,   -1,   -1,  413,  414,  415,  276,  277,  278,  279,
  280,  281,  282,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  293,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  311,   -1,  313,  314,  315,  316,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  324,   -1,   -1,   -1,  328,   -1,
   -1,   -1,   -1,  333,  334,  335,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  343,   -1,   -1,   -1,   -1,  348,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  363,   -1,  365,  366,  367,  368,   -1,
   -1,   -1,  372,  373,   -1,  375,  376,  377,  378,   -1,
  380,  381,  382,   -1,  384,   -1,  386,  387,  388,  389,
  390,  391,  392,  393,  394,  395,  396,  397,  398,  399,
   -1,   -1,   -1,   -1,  404,   -1,   -1,   -1,   -1,   -1,
  410,   -1,   -1,  413,  414,  415,  276,  277,  278,  279,
  280,  281,  282,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  293,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  311,   -1,  313,  314,  315,  316,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  324,   -1,   -1,   -1,  328,   -1,
   -1,   -1,   -1,  333,  334,  335,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  343,   -1,   -1,   -1,   -1,  348,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  363,   -1,  365,  366,  367,  368,   -1,
   -1,   -1,  372,  373,   -1,  375,  376,  377,  378,   -1,
  380,  381,  382,   -1,  384,   -1,  386,  387,  388,  389,
  390,  391,  392,  393,  394,  395,  396,  397,  398,  399,
   -1,   -1,   -1,   -1,  404,   -1,   -1,   -1,   -1,   -1,
  410,   -1,   -1,  413,  414,  415,  276,  277,  278,  279,
  280,  281,  282,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  293,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  311,   -1,  313,  314,  315,  316,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  324,   -1,   -1,   -1,  328,   -1,
   -1,   -1,   -1,  333,  334,  335,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  343,   -1,   -1,   -1,   -1,  348,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  365,  366,  367,  368,   -1,
   -1,   -1,  372,  373,   -1,  375,  376,  377,  378,   -1,
  380,  381,  382,   -1,  384,   -1,  386,  387,  388,  389,
  390,  391,  392,  393,  394,  395,  396,  397,  398,  399,
   -1,   -1,   -1,   -1,  404,   -1,   -1,   -1,   -1,   -1,
  410,   -1,   -1,  413,  414,  415,  276,  277,  278,  279,
  280,  281,  282,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  293,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  311,   -1,  313,  314,  315,  316,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  324,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  333,  334,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  343,   -1,   -1,   -1,   -1,  348,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  365,  366,  367,   -1,   -1,
   -1,   -1,  372,  373,   -1,  375,  376,  377,  378,   -1,
  380,  381,  382,   -1,  384,   -1,  386,  387,  388,  389,
  390,  391,  392,  393,  394,  395,  396,  397,  398,  399,
   -1,   -1,   -1,   -1,  404,   -1,   -1,   -1,   -1,   -1,
  410,   -1,   -1,  413,  414,  415,
};
#define YYFINAL 3
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 416
#if YYDEBUG
#if defined(__cplusplus) || defined(__STDC__)
const char * const socks_yyname[] =
#else
char *socks_yyname[] =
#endif
	{
"end-of-file",0,0,0,0,0,0,0,0,0,"'\\n'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,"'-'","'.'","'/'",0,0,0,0,0,0,0,0,0,0,"':'",0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"'{'",0,"'}'",0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
"SERVERCONFIG","CLIENTCONFIG","DEPRECATED","CLIENTRULE","INTERNAL","EXTERNAL",
"REALM","REALNAME","EXTERNAL_ROTATION","SAMESAME","DEBUGGING","RESOLVEPROTOCOL",
"SRCHOST","NODNSMISMATCH","NODNSUNKNOWN","CHECKREPLYAUTH","EXTENSION","BIND",
"PRIVILEGED","IOTIMEOUT","IOTIMEOUT_TCP","IOTIMEOUT_UDP","NEGOTIATETIMEOUT",
"CONNECTTIMEOUT","TCP_FIN_WAIT","METHOD","CLIENTMETHOD","NONE","GSSAPI","UNAME",
"RFC931","PAM","BSDAUTH","COMPATIBILITY","SAMEPORT","DRAFT_5_05",
"CLIENTCOMPATIBILITY","NECGSSAPI","USERNAME","GROUPNAME","USER_PRIVILEGED",
"USER_UNPRIVILEGED","USER_LIBWRAP","LIBWRAP_FILE","LOGOUTPUT","LOGFILE",
"CHILD_MAXIDLE","CHILD_MAXREQUESTS","ROUTE","VIA","BADROUTE_EXPIRE","MAXFAIL",
"VERDICT_BLOCK","VERDICT_PASS","PAMSERVICENAME","BSDAUTHSTYLENAME",
"BSDAUTHSTYLE","GSSAPISERVICE","GSSAPIKEYTAB","GSSAPIENCTYPE","GSSAPIENC_ANY",
"GSSAPIENC_CLEAR","GSSAPIENC_INTEGRITY","GSSAPIENC_CONFIDENTIALITY",
"GSSAPIENC_PERMESSAGE","GSSAPISERVICENAME","GSSAPIKEYTABNAME","PROTOCOL",
"PROTOCOL_TCP","PROTOCOL_UDP","PROTOCOL_FAKE","PROXYPROTOCOL",
"PROXYPROTOCOL_SOCKS_V4","PROXYPROTOCOL_SOCKS_V5","PROXYPROTOCOL_HTTP",
"PROXYPROTOCOL_UPNP","USER","GROUP","COMMAND","COMMAND_BIND","COMMAND_CONNECT",
"COMMAND_UDPASSOCIATE","COMMAND_BINDREPLY","COMMAND_UDPREPLY","ACTION","LINE",
"LIBWRAPSTART","LIBWRAP_ALLOW","LIBWRAP_DENY","LIBWRAP_HOSTS_ACCESS","OPERATOR",
"SOCKS_LOG","SOCKS_LOG_CONNECT","SOCKS_LOG_DATA","SOCKS_LOG_DISCONNECT",
"SOCKS_LOG_ERROR","SOCKS_LOG_IOOPERATION","IPADDRESS","DOMAINNAME","DIRECT",
"IFNAME","URL","PORT","PORTNUMBER","SERVICENAME","NUMBER","FROM","TO",
"REDIRECT","BANDWIDTH","MAXSESSIONS","UDPPORTRANGE","UDPCONNECTDST","YES","NO",
"BOUNCE","LDAPURL","LDAP_URL","LDAPSSL","LDAPCERTCHECK","LDAPKEEPREALM",
"LDAPBASEDN","LDAP_BASEDN","LDAPBASEDN_HEX","LDAPBASEDN_HEX_ALL","LDAPSERVER",
"LDAPSERVER_NAME","LDAPGROUP","LDAPGROUP_NAME","LDAPGROUP_HEX",
"LDAPGROUP_HEX_ALL","LDAPFILTER","LDAPFILTER_AD","LDAPFILTER_HEX",
"LDAPFILTER_AD_HEX","LDAPATTRIBUTE","LDAPATTRIBUTE_AD","LDAPATTRIBUTE_HEX",
"LDAPATTRIBUTE_AD_HEX","LDAPCERTFILE","LDAPCERTPATH","LDAPPORT","LDAPPORTSSL",
"LDAP_FILTER","LDAP_ATTRIBUTE","LDAP_CERTFILE","LDAP_CERTPATH","LDAPDOMAIN",
"LDAP_DOMAIN","LDAPTIMEOUT","LDAPCACHE","LDAPCACHEPOS","LDAPCACHENEG",
"LDAPKEYTAB","LDAPKEYTABNAME","LDAPDEADTIME","LDAPDEBUG","LDAPDEPTH","LDAPAUTO",
"LDAPSEARCHTIME",
};
#if defined(__cplusplus) || defined(__STDC__)
const char * const socks_yyrule[] =
#else
char *socks_yyrule[] =
#endif
	{"$accept : configtype",
"configtype : serverinit serverline",
"configtype : clientinit clientline",
"serverinit : SERVERCONFIG",
"serverline : serverconfigs rulesorroutes",
"rulesorroutes :",
"rulesorroutes : ruleorroute rulesorroutes",
"ruleorroute : clientrule",
"ruleorroute : rule",
"ruleorroute : route",
"clientline :",
"clientline : clientline '\\n'",
"clientline : clientline clientconfig",
"clientline : clientline route",
"clientinit : CLIENTCONFIG",
"clientconfig : clientoption",
"clientconfig : deprecated",
"serverconfigs : serverconfig",
"serverconfigs : serverconfigs serverconfig",
"serverconfig : global_authmethod",
"serverconfig : global_clientauthmethod",
"serverconfig : deprecated",
"serverconfig : internal",
"serverconfig : external",
"serverconfig : external_rotation",
"serverconfig : logoutput",
"serverconfig : serveroption",
"serverconfig : userids",
"serverconfig : childstate",
"serverconfig : debuging",
"serverconfig : libwrapfiles",
"serverconfig : libwrap_hosts_access",
"serverconfig : udpconnectdst",
"serveroption : compatibility",
"serveroption : extension",
"serveroption : global_routeoption",
"serveroption : resolveprotocol",
"serveroption : realm",
"serveroption : srchost",
"serveroption : timeout",
"timeout : connecttimeout",
"timeout : iotimeout",
"timeout : negotiatetimeout",
"timeout : tcp_fin_timeout",
"deprecated : DEPRECATED",
"route : ROUTE routeinit '{' routeoptions fromto gateway routeoptions '}'",
"routeinit :",
"proxyprotocol : PROXYPROTOCOL ':' proxyprotocols",
"proxyprotocolname : PROXYPROTOCOL_SOCKS_V4",
"proxyprotocolname : PROXYPROTOCOL_SOCKS_V5",
"proxyprotocolname : PROXYPROTOCOL_HTTP",
"proxyprotocolname : PROXYPROTOCOL_UPNP",
"proxyprotocolname : deprecated",
"proxyprotocols : proxyprotocolname",
"proxyprotocols : proxyprotocolname proxyprotocols",
"user : USER ':' usernames",
"username : USERNAME",
"usernames : username",
"usernames : username usernames",
"group : GROUP ':' groupnames",
"groupname : GROUPNAME",
"groupnames : groupname",
"groupnames : groupname groupnames",
"extension : EXTENSION ':' extensions",
"extensionname : BIND",
"extensions : extensionname",
"extensions : extensionname extensions",
"internal : INTERNAL internalinit ':' address",
"internalinit :",
"external : EXTERNAL externalinit ':' externaladdress",
"externalinit :",
"external_rotation : EXTERNAL_ROTATION ':' NONE",
"external_rotation : EXTERNAL_ROTATION ':' SAMESAME",
"external_rotation : EXTERNAL_ROTATION ':' ROUTE",
"clientoption : debuging",
"clientoption : logoutput",
"clientoption : global_routeoption",
"clientoption : resolveprotocol",
"global_routeoption : ROUTE '.' MAXFAIL ':' NUMBER",
"global_routeoption : ROUTE '.' BADROUTE_EXPIRE ':' NUMBER",
"logoutput : LOGOUTPUT ':' logoutputdevices",
"logoutputdevice : LOGFILE",
"logoutputdevices : logoutputdevice",
"logoutputdevices : logoutputdevice logoutputdevices",
"childstate : CHILD_MAXIDLE ':' YES",
"childstate : CHILD_MAXIDLE ':' NO",
"childstate : CHILD_MAXREQUESTS ':' NUMBER",
"userids : user_privileged",
"userids : user_unprivileged",
"userids : user_libwrap",
"user_privileged : USER_PRIVILEGED ':' userid",
"user_unprivileged : USER_UNPRIVILEGED ':' userid",
"user_libwrap : USER_LIBWRAP ':' userid",
"userid : USERNAME",
"iotimeout : IOTIMEOUT ':' NUMBER",
"iotimeout : IOTIMEOUT_TCP ':' NUMBER",
"iotimeout : IOTIMEOUT_UDP ':' NUMBER",
"negotiatetimeout : NEGOTIATETIMEOUT ':' NUMBER",
"connecttimeout : CONNECTTIMEOUT ':' NUMBER",
"tcp_fin_timeout : TCP_FIN_WAIT ':' NUMBER",
"debuging : DEBUGGING ':' NUMBER",
"libwrapfiles : libwrap_allowfile",
"libwrapfiles : libwrap_denyfile",
"libwrap_allowfile : LIBWRAP_ALLOW ':' LIBWRAP_FILE",
"libwrap_denyfile : LIBWRAP_DENY ':' LIBWRAP_FILE",
"libwrap_hosts_access : LIBWRAP_HOSTS_ACCESS ':' YES",
"libwrap_hosts_access : LIBWRAP_HOSTS_ACCESS ':' NO",
"udpconnectdst : UDPCONNECTDST ':' YES",
"udpconnectdst : UDPCONNECTDST ':' NO",
"compatibility : COMPATIBILITY ':' compatibilitynames",
"compatibilityname : SAMEPORT",
"compatibilityname : DRAFT_5_05",
"compatibilitynames : compatibilityname",
"compatibilitynames : compatibilityname compatibilitynames",
"resolveprotocol : RESOLVEPROTOCOL ':' resolveprotocolname",
"resolveprotocolname : PROTOCOL_FAKE",
"resolveprotocolname : PROTOCOL_TCP",
"resolveprotocolname : PROTOCOL_UDP",
"srchost : SRCHOST ':' srchostoptions",
"srchostoption : NODNSMISMATCH",
"srchostoption : NODNSUNKNOWN",
"srchostoption : CHECKREPLYAUTH",
"srchostoptions : srchostoption",
"srchostoptions : srchostoption srchostoptions",
"realm : REALM ':' REALNAME",
"authmethod : METHOD ':' authmethods",
"authmethods : authmethodname",
"authmethods : authmethodname authmethods",
"$$1 :",
"global_authmethod : METHOD ':' $$1 authmethods",
"$$2 :",
"global_clientauthmethod : CLIENTMETHOD ':' $$2 authmethods",
"authmethodname : NONE",
"authmethodname : GSSAPI",
"authmethodname : UNAME",
"authmethodname : RFC931",
"authmethodname : PAM",
"authmethodname : BSDAUTH",
"clientrule : CLIENTRULE verdict '{' clientruleoptions fromto clientruleoptions '}'",
"clientruleoption : option",
"clientruleoption : bandwidth",
"clientruleoption : protocol",
"clientruleoption : redirect",
"clientruleoptions :",
"clientruleoptions : clientruleoption clientruleoptions",
"rule : verdict '{' ruleoptions fromto ruleoptions '}'",
"ruleoption : option",
"ruleoption : bandwidth",
"ruleoption : command",
"ruleoption : udpportrange",
"ruleoption : protocol",
"ruleoption : proxyprotocol",
"ruleoption : redirect",
"ruleoptions :",
"ruleoptions : ruleoption ruleoptions",
"option : authmethod",
"option : clientcompatibility",
"option : libwrap",
"option : log",
"option : pamservicename",
"option : bsdauthstylename",
"option : gssapiservicename",
"option : gssapikeytab",
"option : gssapienctype",
"option : lurl",
"option : ldapauto",
"option : ldapdomain",
"option : ldapdebug",
"option : ldapdepth",
"option : lbasedn",
"option : lbasedn_hex",
"option : lbasedn_hex_all",
"option : ldapport",
"option : ldapportssl",
"option : ldapssl",
"option : ldapcertcheck",
"option : ldapkeeprealm",
"option : ldapfilter",
"option : ldapattribute",
"option : ldapfilter_ad",
"option : ldapattribute_ad",
"option : ldapfilter_hex",
"option : ldapattribute_hex",
"option : ldapfilter_ad_hex",
"option : ldapattribute_ad_hex",
"option : ldapcertfile",
"option : ldapcertpath",
"option : lgroup",
"option : lgroup_hex",
"option : lgroup_hex_all",
"option : lserver",
"option : ldapkeytab",
"option : user",
"option : group",
"option : timeout",
"option : bounce",
"option : session",
"ldapdebug : LDAPDEBUG ':' NUMBER",
"ldapdebug : LDAPDEBUG ':' '-' NUMBER",
"ldapdomain : LDAPDOMAIN ':' LDAP_DOMAIN",
"ldapdepth : LDAPDEPTH ':' NUMBER",
"ldapcertfile : LDAPCERTFILE ':' LDAP_CERTFILE",
"ldapcertpath : LDAPCERTPATH ':' LDAP_CERTPATH",
"lurl : LDAPURL ':' LDAP_URL",
"lbasedn : LDAPBASEDN ':' LDAP_BASEDN",
"lbasedn_hex : LDAPBASEDN_HEX ':' LDAP_BASEDN",
"lbasedn_hex_all : LDAPBASEDN_HEX_ALL ':' LDAP_BASEDN",
"ldapport : LDAPPORT ':' NUMBER",
"ldapportssl : LDAPPORTSSL ':' NUMBER",
"ldapssl : LDAPSSL ':' YES",
"ldapssl : LDAPSSL ':' NO",
"ldapauto : LDAPAUTO ':' YES",
"ldapauto : LDAPAUTO ':' NO",
"ldapcertcheck : LDAPCERTCHECK ':' YES",
"ldapcertcheck : LDAPCERTCHECK ':' NO",
"ldapkeeprealm : LDAPKEEPREALM ':' YES",
"ldapkeeprealm : LDAPKEEPREALM ':' NO",
"ldapfilter : LDAPFILTER ':' LDAP_FILTER",
"ldapfilter_ad : LDAPFILTER_AD ':' LDAP_FILTER",
"ldapfilter_hex : LDAPFILTER_HEX ':' LDAP_FILTER",
"ldapfilter_ad_hex : LDAPFILTER_AD_HEX ':' LDAP_FILTER",
"ldapattribute : LDAPATTRIBUTE ':' LDAP_ATTRIBUTE",
"ldapattribute_ad : LDAPATTRIBUTE_AD ':' LDAP_ATTRIBUTE",
"ldapattribute_hex : LDAPATTRIBUTE_HEX ':' LDAP_ATTRIBUTE",
"ldapattribute_ad_hex : LDAPATTRIBUTE_AD_HEX ':' LDAP_ATTRIBUTE",
"lgroup_hex : LDAPGROUP_HEX ':' LDAPGROUP_NAME",
"lgroup_hex_all : LDAPGROUP_HEX_ALL ':' LDAPGROUP_NAME",
"lgroup : LDAPGROUP ':' LDAPGROUP_NAME",
"lserver : LDAPSERVER ':' LDAPSERVER_NAME",
"ldapkeytab : LDAPKEYTAB ':' LDAPKEYTABNAME",
"clientcompatibility : CLIENTCOMPATIBILITY ':' clientcompatibilitynames",
"clientcompatibilityname : NECGSSAPI",
"clientcompatibilitynames : clientcompatibilityname",
"clientcompatibilitynames : clientcompatibilityname clientcompatibilitynames",
"verdict : VERDICT_BLOCK",
"verdict : VERDICT_PASS",
"command : COMMAND ':' commands",
"commands : commandname",
"commands : commandname commands",
"commandname : COMMAND_BIND",
"commandname : COMMAND_CONNECT",
"commandname : COMMAND_UDPASSOCIATE",
"commandname : COMMAND_BINDREPLY",
"commandname : COMMAND_UDPREPLY",
"protocol : PROTOCOL ':' protocols",
"protocols : protocolname",
"protocols : protocolname protocols",
"protocolname : PROTOCOL_TCP",
"protocolname : PROTOCOL_UDP",
"fromto : srcaddress dstaddress",
"redirect : REDIRECT rdr_fromaddress rdr_toaddress",
"redirect : REDIRECT rdr_fromaddress",
"redirect : REDIRECT rdr_toaddress",
"session : maxsessions",
"maxsessions : MAXSESSIONS ':' NUMBER",
"bandwidth : BANDWIDTH ':' NUMBER",
"log : SOCKS_LOG ':' logs",
"logname : SOCKS_LOG_CONNECT",
"logname : SOCKS_LOG_DATA",
"logname : SOCKS_LOG_DISCONNECT",
"logname : SOCKS_LOG_ERROR",
"logname : SOCKS_LOG_IOOPERATION",
"logs : logname",
"logs : logname logs",
"pamservicename : PAMSERVICENAME ':' SERVICENAME",
"bsdauthstylename : BSDAUTHSTYLE ':' BSDAUTHSTYLENAME",
"gssapiservicename : GSSAPISERVICE ':' GSSAPISERVICENAME",
"gssapikeytab : GSSAPIKEYTAB ':' GSSAPIKEYTABNAME",
"gssapienctype : GSSAPIENCTYPE ':' gssapienctypes",
"gssapienctypename : GSSAPIENC_ANY",
"gssapienctypename : GSSAPIENC_CLEAR",
"gssapienctypename : GSSAPIENC_INTEGRITY",
"gssapienctypename : GSSAPIENC_CONFIDENTIALITY",
"gssapienctypename : GSSAPIENC_PERMESSAGE",
"gssapienctypes : gssapienctypename",
"gssapienctypes : gssapienctypename gssapienctypes",
"bounce : BOUNCE bounce_to ':' address",
"libwrap : LIBWRAPSTART ':' LINE",
"srcaddress : from ':' address",
"dstaddress : to ':' address",
"rdr_fromaddress : rdr_from ':' address",
"rdr_toaddress : rdr_to ':' address",
"gateway : via ':' gwaddress",
"routeoption : command",
"routeoption : clientcompatibility",
"routeoption : extension",
"routeoption : protocol",
"routeoption : gssapiservicename",
"routeoption : gssapikeytab",
"routeoption : gssapienctype",
"routeoption : proxyprotocol",
"routeoption : authmethod",
"routeoptions :",
"routeoptions : routeoption routeoptions",
"from : FROM",
"to : TO",
"rdr_from : FROM",
"rdr_to : TO",
"bounce_to : TO",
"via : VIA",
"externaladdress : ipaddress",
"externaladdress : domain",
"externaladdress : ifname",
"address : ipaddress '/' netmask port",
"$$3 :",
"address : ipaddress $$3 port",
"address : domain port",
"address : ifname port",
"gwaddress : ipaddress gwport",
"gwaddress : domain gwport",
"gwaddress : ifname gwport",
"gwaddress : url",
"gwaddress : direct",
"ipaddress : IPADDRESS",
"netmask : NUMBER",
"netmask : IPADDRESS",
"domain : DOMAINNAME",
"ifname : IFNAME",
"direct : DIRECT",
"url : URL",
"port :",
"port : PORT ':' portnumber",
"port : PORT portoperator portnumber",
"port : PORT portrange",
"gwport :",
"gwport : PORT portoperator portnumber",
"portnumber : portservice",
"portnumber : portstart",
"portrange : portstart '-' portend",
"portstart : PORTNUMBER",
"portend : PORTNUMBER",
"portservice : SERVICENAME",
"portoperator : OPERATOR",
"udpportrange : UDPPORTRANGE ':' udpportrange_start '-' udpportrange_end",
"udpportrange_start : PORTNUMBER",
"udpportrange_end : PORTNUMBER",
};
#endif
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 10000
#define YYMAXDEPTH 10000
#endif
#endif
#define YYINITSTACKSIZE 200
/* LINTUSED */
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short *yyss;
short *yysslim;
YYSTYPE *yyvs;
int yystacksize;
#line 1954 "config_parse.y"

#define INTERACTIVE      0

extern FILE *yyin;

int socks_parseinit;

int
parseconfig(filename)
   const char *filename;
{
   const char *function = "parseconfig()";
   struct stat statbuf;
   int havefile;

#if !SOCKS_CLIENT
   if (sockscf.state.init) {
      /* in case needed to read config-file or operations pertaining to it. */
      sockd_priv(SOCKD_PRIV_PRIVILEGED, PRIV_ON);

      if (yyin != NULL)
         fclose(yyin);
   }
#endif /* SERVER */

   yyin = fopen(filename, "r");

#if !SOCKS_CLIENT 
   if (sockscf.state.init)
      sockd_priv(SOCKD_PRIV_PRIVILEGED, PRIV_OFF);
#endif /* SERVER */


#if !SOCKS_CLIENT && !HAVE_PRIVILEGES
   /*
    * uid, read from configfile.  But save olds one first, in case we
    * need them to reopen logfiles.
    */

   olduserid = sockscf.uid;
   bzero(&sockscf.uid, sizeof(sockscf.uid));
#endif /* !SOCKS_CLIENT && !HAVE_PRIVILEGES */

   if (yyin == NULL
   ||  (stat(filename, &statbuf) == 0 && statbuf.st_size == 0)) {
      if (yyin == NULL)
         swarn("%s: could not open %s", function, filename);

      havefile              = 0;
      sockscf.option.debug  = 1;
   }
   else {
      socks_parseinit = 0;
#if YYDEBUG
      yydebug         = 0;
#endif /* YYDEBUG */

      yylineno      = 1;
      errno         = 0;   /* don't report old errors in yyparse(). */
      havefile      = 1;

      parsingconfig = 1;
      yyparse();
      parsingconfig = 0;

#if SOCKS_CLIENT
      fclose(yyin);
#else
      /*
       * Leave it open so that if we get a sighup later, we are
       * always guranteed to have a descriptor we can close/reopen
       * to parse the configfile.
       */
      sockscf.configfd = fileno(yyin);
#endif
   }

   errno = 0;

#if SOCKS_CLIENT /* assume server admin can set things up correctly himself. */
   parseclientenv();
#endif

   return havefile ? 0 : -1;
}

void
yyerror(const char *fmt, ...)
{
   va_list ap;
   char buf[2048];
   size_t bufused;

   /* LINTED pointer casts may be troublesome */
   va_start(ap, fmt);

   if (parsingconfig)
      bufused = snprintfn(buf, sizeof(buf),
                          "%s: error on line %d, near \"%.20s\": ",
                          sockscf.option.configfile, yylineno,
                          (yytext == NULL || *yytext == NUL) ?
                          "'start of line'" : yytext);

   else
      bufused = snprintfn(buf, sizeof(buf), "error: ");

   vsnprintf(&buf[bufused], sizeof(buf) - bufused, fmt, ap);

   /* LINTED expression has null effect */
   va_end(ap);

   if (errno)
      serr(EXIT_FAILURE, "%s", buf);
   serrx(EXIT_FAILURE, "%s", buf);
}

void
yywarn(const char *fmt, ...)
{
   va_list ap;
   char buf[2048];
   size_t bufused;

   /* LINTED pointer casts may be troublesome */
   va_start(ap, fmt);

   if (parsingconfig)
      bufused = snprintfn(buf, sizeof(buf),
                         "%s: warning on line %d, near \"%.10s\": ",
                         sockscf.option.configfile, yylineno,
                         (yytext == NULL || *yytext == NUL) ?
                         "'start of line'" : yytext);
   else
      bufused = snprintfn(buf, sizeof(buf), "error: ");

   vsnprintf(&buf[bufused], sizeof(buf) - bufused, fmt, ap);

   /* LINTED expression has null effect */
   va_end(ap);

   if (errno)
      swarn("%s", buf);
   swarnx("%s", buf);
}

static void
addrinit(addr, _netmask_required)
   struct ruleaddr_t *addr;
   const int _netmask_required;
{

   atype            = &addr->atype;
   ipaddr           = &addr->addr.ipv4.ip;
   netmask          = &addr->addr.ipv4.mask;
   domain           = addr->addr.domain;
   ifname           = addr->addr.ifname;
   port_tcp         = &addr->port.tcp;
   port_udp         = &addr->port.udp;
   operator         = &addr->operator;

   netmask_required = _netmask_required;
   ruleaddr         = addr;
}

static void
gwaddrinit(addr)
   gwaddr_t *addr;
{
   static enum operator_t operatormem;

   atype    = &addr->atype;
   ipaddr   = &addr->addr.ipv4;
   domain   = addr->addr.domain;
   ifname   = addr->addr.ifname;
   url      = addr->addr.urlname;
   port_tcp = &addr->port;
   port_udp = &addr->port;
   operator = &operatormem; /* no operator in gwaddr and not used. */
}

#if SOCKS_CLIENT
static void
parseclientenv(void)
{
   const char *function = "parseclientenv()";
   char *proxyserver, *logfile, *debug;

   if ((logfile = socks_getenv("SOCKS_LOGOUTPUT", dontcare)) != NULL)
      socks_addlogfile(logfile);

   if ((debug = socks_getenv("SOCKS_DEBUG", dontcare)) != NULL)
      sockscf.option.debug = atoi(debug);

   if ((proxyserver = socks_getenv("SOCKS4_SERVER", dontcare)) != NULL
   ||  (proxyserver = socks_getenv("SOCKS5_SERVER", dontcare)) != NULL
   ||  (proxyserver = socks_getenv("SOCKS_SERVER",  dontcare)) != NULL
   ||  (proxyserver = socks_getenv("HTTP_PROXY",    dontcare)) != NULL) {
      char ipstring[INET_ADDRSTRLEN], *portstring;
      struct sockaddr_in saddr;
      struct route_t route;
      struct ruleaddr_t raddr;

      slog(LOG_DEBUG, "%s: found proxyserver set in environment, value %s",
      function, proxyserver);

      if ((portstring = strchr(proxyserver, ':')) == NULL)
         serrx(EXIT_FAILURE, "%s: illegal format for port specification "
         "in SOCKS_SERVER %s: missing ':' delimiter", function, proxyserver);

      if (atoi(portstring + 1) < 1 || atoi(portstring + 1) > 0xffff)
         serrx(EXIT_FAILURE, "%s: illegal value for port specification "
         "in SOCKS_SERVER %s: must be between %d and %d",
         function, proxyserver, 1, 0xffff);

      if (portstring - proxyserver == 0
      || (size_t)(portstring - proxyserver) > sizeof(ipstring) - 1)
         serrx(EXIT_FAILURE, "%s: illegal format for ip address specification "
         "in SOCKS_SERVER %s: too short/long", function, proxyserver);

      strncpy(ipstring, proxyserver, (size_t)(portstring - proxyserver));
      ipstring[portstring - proxyserver] = NUL;
      ++portstring;

      bzero(&saddr, sizeof(saddr));
      saddr.sin_family = AF_INET;
      if (inet_pton(saddr.sin_family, ipstring, &saddr.sin_addr) != 1)
         serr(EXIT_FAILURE, "%s: illegal format for ip address specification "
         "in SOCKS_SERVER %s", function, ipstring);
      saddr.sin_port = htons(atoi(portstring));

      memset(&route, 0, sizeof(route));
      route.src.atype                           = SOCKS_ADDR_IPV4;
      route.src.addr.ipv4.ip.s_addr             = htonl(0);
      route.src.addr.ipv4.mask.s_addr           = htonl(0);
      route.src.port.tcp                        = route.src.port.udp = htons(0);
      route.src.operator                        = none;

      route.dst = route.src;

      ruleaddr2gwaddr(sockaddr2ruleaddr((struct sockaddr *)&saddr, &raddr),
      &route.gw.addr);

      if (socks_getenv("SOCKS4_SERVER", dontcare)      != NULL)
         route.gw.state.proxyprotocol.socks_v4 = 1;
      else if (socks_getenv("SOCKS5_SERVER", dontcare) != NULL)
         route.gw.state.proxyprotocol.socks_v5 = 1;
      else if (socks_getenv("SOCKS_SERVER", dontcare)  != NULL) {
         route.gw.state.proxyprotocol.socks_v5 = 1;
         route.gw.state.proxyprotocol.socks_v4 = 1;
      }
      else if (socks_getenv("HTTP_PROXY", dontcare)    != NULL)
         route.gw.state.proxyprotocol.http = 1;
      else
         SERRX(0); /* NOTREACHED */

      socks_addroute(&route, 1);
   }
   else if ((proxyserver = socks_getenv("UPNP_IGD", dontcare)) != NULL) {
      /*
       * Should be either an interface name (the interface to broadcast
       * for a response from the igd-device), "broadcast", to indicate
       * all interfaces, or a full url to the igd.
       */
      struct route_t route;

      memset(&route, 0, sizeof(route));
      route.src.atype                 = SOCKS_ADDR_IPV4;
      route.src.addr.ipv4.ip.s_addr   = htonl(0);
      route.src.addr.ipv4.mask.s_addr = htonl(0);
      route.src.port.tcp              = route.src.port.udp = htons(0);
      route.src.operator              = none;

      route.dst                       = route.src;

      /*
       * url or interface to broadcast for a response for?
       */
      if (strncasecmp(proxyserver, "http://", strlen("http://")) == 0) {
         route.gw.addr.atype = SOCKS_ADDR_URL;
         strncpy(route.gw.addr.addr.urlname, proxyserver,
                 sizeof(route.gw.addr.addr.urlname));

         if (route.gw.addr.addr.urlname[sizeof(route.gw.addr.addr.urlname) - 1]
         != NUL)
            serrx(EXIT_FAILURE, "url for igd, \"%s\", is too.  "
                                "Max is %lu characters",
                                proxyserver,
                                (unsigned long)sizeof(
                                               route.gw.addr.addr.urlname) - 1);

         route.gw.state.proxyprotocol.upnp = 1;
         socks_addroute(&route, 1);
      }
      else if (strcasecmp(proxyserver, "broadcast") == 0) {
         /*
          * Don't know what interface the igd is on, so add routes
          * for it on all interfaces.  Hopefully at least one interface
          * will get a response.
          */
         struct ifaddrs *ifap, *iface;

         route.gw.addr.atype                 = SOCKS_ADDR_IFNAME;
         route.gw.state.proxyprotocol.upnp = 1;

         if (getifaddrs(&ifap) == -1)
            serr(EXIT_FAILURE, "%s: getifaddrs() failed to get interface list",
            function);

         for (iface = ifap; iface != NULL; iface = iface->ifa_next) {
            if (iface->ifa_addr                          == NULL
            ||  iface->ifa_addr->sa_family               != AF_INET
            ||  TOIN(iface->ifa_addr)->sin_addr.s_addr   == htonl(0)
            ||  !(iface->ifa_flags & (IFF_UP | IFF_MULTICAST))
            ||  iface->ifa_flags & (IFF_LOOPBACK | IFF_POINTOPOINT))
               continue;

            if (strlen(iface->ifa_name)
            > sizeof(route.gw.addr.addr.ifname) - 1) {
               serr(1, "%s: ifname %s is too long, max is %lu",
               function, iface->ifa_name,
               (unsigned long)(sizeof(route.gw.addr.addr.ifname) - 1));
            }

            strcpy(route.gw.addr.addr.ifname, iface->ifa_name);
            socks_addroute(&route, 1);
         }

         freeifaddrs(ifap);
      }
      else { /* must be an interface name. */
         /*
          * check that the given interface exists and has an address
          */
         struct sockaddr addr, mask;

         if (ifname2sockaddr(proxyserver, 0, &addr, &mask) == NULL)
            serr(1, "%s: can't find interface named %s with ip configured",
            function, proxyserver);

         route.gw.addr.atype = SOCKS_ADDR_IFNAME;

         if (strlen(proxyserver) > sizeof(route.gw.addr.addr.ifname) - 1)
            serr(1, "%s: ifname %s is too long, max is %lu",
            function, proxyserver,
            (unsigned long)(sizeof(route.gw.addr.addr.ifname) - 1));

         strcpy(route.gw.addr.addr.ifname, proxyserver);

         route.gw.state.proxyprotocol.upnp = 1;
         socks_addroute(&route, 1);
      }
   }

   if (socks_getenv("SOCKS_AUTOADD_LANROUTES", isfalse) == NULL) {
      /*
       * assume it's good to add direct routes for the lan also.
       */
      struct ifaddrs *ifap;

      slog(LOG_DEBUG, "%s: auto-adding direct routes for lan ...", function);

      if (getifaddrs(&ifap) == 0) {
         struct ifaddrs *iface;

         for (iface = ifap; iface != NULL; iface = iface->ifa_next)
            if (iface->ifa_addr            != NULL
            &&  iface->ifa_addr->sa_family == AF_INET)
               socks_autoadd_directroute(
               (const struct sockaddr_in *)iface->ifa_addr,
               (const struct sockaddr_in *)iface->ifa_netmask);

         freeifaddrs(ifap);
      }
   }
   else
      slog(LOG_DEBUG, "%s: not auto-adding direct routes for lan", function);
}

#else /* !SOCKS_CLIENT */

static void
rulereset(void)
{

   timeout = &sockscf.timeout; /* default is global timeout, unless in a rule */
}

static void
ruleinit(rule)
   struct rule_t *rule;
{

   bzero(rule, sizeof(*rule));

   rule->linenumber        = yylineno;

   command                 = &rule->state.command;
   methodv                 = rule->state.methodv;
   methodc                 = &rule->state.methodc;
   protocol                = &rule->state.protocol;
   proxyprotocol           = &rule->state.proxyprotocol;
   timeout                 = &rule->timeout;
   *timeout                = sockscf.timeout; /* default: same as global. */

#if HAVE_GSSAPI
   gssapiservicename = rule->state.gssapiservicename;
   gssapikeytab      = rule->state.gssapikeytab;
   gssapiencryption  = &rule->state.gssapiencryption;
#endif /* HAVE_GSSAPI */

#if HAVE_LDAP
   ldap              = &rule->state.ldap;
#endif

   bzero(&src, sizeof(src));
   src.atype = SOCKS_ADDR_NOTSET;

   dst = rdr_from = rdr_to = src;

}

#endif /* !SOCKS_CLIENT */
#line 1971 "config_parse.c"
/* allocate initial stack or double stack size, up to YYMAXDEPTH */
#if defined(__cplusplus) || defined(__STDC__)
static int yygrowstack(void)
#else
static int yygrowstack()
#endif
{
    int newsize, i;
    short *newss;
    YYSTYPE *newvs;

    if ((newsize = yystacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return -1;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;
    i = yyssp - yyss;
#ifdef SIZE_MAX
#define YY_SIZE_MAX SIZE_MAX
#else
#define YY_SIZE_MAX 0xffffffffU
#endif
    if (newsize && YY_SIZE_MAX / newsize < sizeof *newss)
        goto bail;
    newss = yyss ? (short *)realloc(yyss, newsize * sizeof *newss) :
      (short *)malloc(newsize * sizeof *newss); /* overflow check above */
    if (newss == NULL)
        goto bail;
    yyss = newss;
    yyssp = newss + i;
    if (newsize && YY_SIZE_MAX / newsize < sizeof *newvs)
        goto bail;
    newvs = yyvs ? (YYSTYPE *)realloc(yyvs, newsize * sizeof *newvs) :
      (YYSTYPE *)malloc(newsize * sizeof *newvs); /* overflow check above */
    if (newvs == NULL)
        goto bail;
    yyvs = newvs;
    yyvsp = newvs + i;
    yystacksize = newsize;
    yysslim = yyss + newsize - 1;
    return 0;
bail:
    if (yyss)
            free(yyss);
    if (yyvs)
            free(yyvs);
    yyss = yyssp = NULL;
    yyvs = yyvsp = NULL;
    yystacksize = 0;
    return -1;
}

#define YYABORT goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab
int
#if defined(__cplusplus) || defined(__STDC__)
yyparse(void)
#else
yyparse()
#endif
{
    int yym, yyn, yystate;
#if YYDEBUG
#if defined(__cplusplus) || defined(__STDC__)
    const char *yys;
#else /* !(defined(__cplusplus) || defined(__STDC__)) */
    char *yys;
#endif /* !(defined(__cplusplus) || defined(__STDC__)) */

    if ((yys = getenv("YYDEBUG")))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif /* YYDEBUG */

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    if (yyss == NULL && yygrowstack()) goto yyoverflow;
    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if ((yyn = yydefred[yystate]) != 0) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yyssp >= yysslim && yygrowstack())
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#if defined(lint) || defined(__GNUC__)
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#if defined(lint) || defined(__GNUC__)
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yysslim && yygrowstack())
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    if (yym)
        yyval = yyvsp[1-yym];
    else
        memset(&yyval, 0, sizeof yyval);
    switch (yyn)
    {
case 3:
#line 330 "config_parse.y"
{
#if !SOCKS_CLIENT
      protocol  = &protocolmem;
      extension = &sockscf.extension;
#endif /* !SOCKS_CLIENT*/
   }
break;
case 5:
#line 342 "config_parse.y"
{ yyval.string = NULL; }
break;
case 10:
#line 351 "config_parse.y"
{ yyval.string = NULL; }
break;
case 14:
#line 358 "config_parse.y"
{
   }
break;
case 44:
#line 400 "config_parse.y"
{
      yyerror("given keyword, \"%s\", is deprecated", yyvsp[0].string);
   }
break;
case 45:
#line 405 "config_parse.y"
{
      route.src       = src;
      route.dst       = dst;
      route.gw.addr   = gw;
      route.gw.state  = state;

      socks_addroute(&route, 1);
   }
break;
case 46:
#line 415 "config_parse.y"
{
      command             = &state.command;
      extension           = &state.extension;
      methodv             = state.methodv;
      methodc             = &state.methodc;
      protocol            = &state.protocol;
      proxyprotocol       = &state.proxyprotocol;

#if HAVE_GSSAPI
      gssapiservicename = state.gssapiservicename;
      gssapikeytab      = state.gssapikeytab;
      gssapiencryption  = &state.gssapiencryption;
#endif /* HAVE_GSSAPI */
#if HAVE_LDAP
      ldap              = &state.ldap;
#endif /* HAVE_LDAP*/

      bzero(&state, sizeof(state));
      bzero(&route, sizeof(route));
      bzero(&gw, sizeof(gw));
      bzero(&src, sizeof(src));
      bzero(&dst, sizeof(dst));
      src.atype = SOCKS_ADDR_IPV4;
      dst.atype = SOCKS_ADDR_IPV4;
   }
break;
case 48:
#line 446 "config_parse.y"
{
         proxyprotocol->socks_v4    = 1;
   }
break;
case 49:
#line 449 "config_parse.y"
{
         proxyprotocol->socks_v5    = 1;
   }
break;
case 50:
#line 452 "config_parse.y"
{
         proxyprotocol->http        = 1;
   }
break;
case 51:
#line 455 "config_parse.y"
{
         proxyprotocol->upnp        = 1;
   }
break;
case 56:
#line 468 "config_parse.y"
{
#if !SOCKS_CLIENT 
      if (addlinkedname(&rule.user, yyvsp[0].string) == NULL)
         yyerror(NOMEM);
#endif /* !SOCKS_CLIENT */
   }
break;
case 60:
#line 483 "config_parse.y"
{
#if !SOCKS_CLIENT
      if (addlinkedname(&rule.group, yyvsp[0].string) == NULL)
         yyerror(NOMEM);
#endif /* !SOCKS_CLIENT */
   }
break;
case 64:
#line 498 "config_parse.y"
{
         extension->bind = 1;
   }
break;
case 67:
#line 507 "config_parse.y"
{
#if !SOCKS_CLIENT
#if BAREFOOTD
      yyerror("\"internal:\" specification is not used in %s", PACKAGE);
#endif /* BAREFOOTD */

      addinternal(ruleaddr, SOCKS_TCP);
#endif /* !SOCKS_CLIENT */
   }
break;
case 68:
#line 518 "config_parse.y"
{
#if !SOCKS_CLIENT
   static struct ruleaddr_t mem;
   struct servent   *service;

   addrinit(&mem, 0);
   bzero(protocol, sizeof(*protocol));

   /* set default port. */
   if ((service = getservbyname("socks", "tcp")) == NULL)
      *port_tcp = htons(SOCKD_PORT);
   else
      *port_tcp = (in_port_t)service->s_port;
#endif /* !SOCKS_CLIENT */
   }
break;
case 69:
#line 535 "config_parse.y"
{
#if !SOCKS_CLIENT
      addexternal(ruleaddr);
#endif /* !SOCKS_CLIENT */
   }
break;
case 70:
#line 542 "config_parse.y"
{
#if !SOCKS_CLIENT
      static struct ruleaddr_t mem;

      addrinit(&mem, 0);
#endif /* !SOCKS_CLIENT */
   }
break;
case 71:
#line 551 "config_parse.y"
{
#if !SOCKS_CLIENT
      sockscf.external.rotation = ROTATION_NONE;
   }
break;
case 72:
#line 555 "config_parse.y"
{
      sockscf.external.rotation = ROTATION_SAMESAME;
   }
break;
case 73:
#line 558 "config_parse.y"
{
#if !HAVE_ROUTE_SOURCE
      yyerror("don't have code to discover route/address source on platform");
#else /* !HAVE_ROUTE_SOURCE */
      sockscf.external.rotation = ROTATION_ROUTE;
#endif /* HAVE_ROUTE_SOURCE */
#endif /* SOCKS_SERVER */
   }
break;
case 78:
#line 574 "config_parse.y"
{
      const int value = atoi(yyvsp[0].string);

      if (value < 0)
         yyerror("max route fails can not be negative (%d)  Use \"0\" to "
                 "indicate routes should never be marked as bad", 
                 value);

      sockscf.routeoptions.maxfail = value;
   }
break;
case 79:
#line 584 "config_parse.y"
{
      const int value = atoi(yyvsp[0].string);

      if (value < 0)
         yyerror("route failure expiry can not be negative (%d)  Use \"0\" to "
                 "indicate the bad route marking should never expire",
                 value);

      sockscf.routeoptions.badexpire = value;
   }
break;
case 81:
#line 599 "config_parse.y"
{
#if !SOCKS_CLIENT && !HAVE_PRIVILEGES
   /*
    * We dont enforce that userid must be set before logfiles, so
    * use the old userid, if any, when (re)opening logfiles.
    */
   const struct userid_t currentuserid = sockscf.uid;;
   sockscf.uid = olduserid;
#endif /* !SOCKS_CLIENT && !HAVE_PRIVILEGES */

   socks_addlogfile(yyvsp[0].string);

#if !SOCKS_CLIENT && !HAVE_PRIVILEGES
   sockscf.uid = currentuserid;
#endif /* !SOCKS_CLIENT && !HAVE_PRIVILEGES */
}
break;
case 84:
#line 620 "config_parse.y"
{
#if !SOCKS_CLIENT
      sockscf.child.maxidle = SOCKD_FREESLOTS * 2;
   }
break;
case 85:
#line 624 "config_parse.y"
{
      sockscf.child.maxidle = 0;
   }
break;
case 86:
#line 627 "config_parse.y"
{
      sockscf.child.maxrequests = (size_t)atol(yyvsp[0].string);
#endif /* !SOCKS_CLIENT */
   }
break;
case 90:
#line 638 "config_parse.y"
{
#if !SOCKS_CLIENT
#if HAVE_PRIVILEGES
      yyerror("userid-settings not used on platforms with privileges");
#else
      sockscf.uid.privileged         = yyvsp[0].uid;
      sockscf.uid.privileged_isset   = 1;
#endif /* !HAVE_PRIVILEGES */
#endif /* !SOCKS_CLIENT */
   }
break;
case 91:
#line 650 "config_parse.y"
{
#if !SOCKS_CLIENT
#if HAVE_PRIVILEGES
      yyerror("userid-settings not used on platforms with privileges");
#else
      sockscf.uid.unprivileged         = yyvsp[0].uid;
      sockscf.uid.unprivileged_isset   = 1;
#endif /* !HAVE_PRIVILEGES */
#endif /* !SOCKS_CLIENT */
   }
break;
case 92:
#line 662 "config_parse.y"
{
#if HAVE_LIBWRAP && (!SOCKS_CLIENT)
#if HAVE_PRIVILEGES
      yyerror("userid-settings not used on platforms with privileges");
#else
      sockscf.uid.libwrap         = yyvsp[0].uid;
      sockscf.uid.libwrap_isset   = 1;
#endif /* !HAVE_PRIVILEGES */
#else  /* !HAVE_LIBWRAP && (!SOCKS_CLIENT) */
      yyerror("libwrapsupport not compiled in");
#endif /* !HAVE_LIBWRAP (!SOCKS_CLIENT)*/
   }
break;
case 93:
#line 677 "config_parse.y"
{
      struct passwd *pw;

      if ((pw = socks_getpwnam(yyvsp[0].string)) == NULL)
         serrx(EXIT_FAILURE, "no such user \"%s\"", yyvsp[0].string);
      else
         yyval.uid = pw->pw_uid;
   }
break;
case 94:
#line 687 "config_parse.y"
{
#if !SOCKS_CLIENT
      timeout->tcpio = (size_t)atol(yyvsp[0].string);
      timeout->udpio = timeout->tcpio;
   }
break;
case 95:
#line 692 "config_parse.y"
{
      timeout->tcpio = (size_t)atol(yyvsp[0].string);
   }
break;
case 96:
#line 695 "config_parse.y"
{
      timeout->udpio = (size_t)atol(yyvsp[0].string);
#endif /* !SOCKS_CLIENT */
   }
break;
case 97:
#line 701 "config_parse.y"
{
#if !SOCKS_CLIENT
      timeout->negotiate = (size_t)atol(yyvsp[0].string);
#endif /* !SOCKS_CLIENT */
   }
break;
case 98:
#line 708 "config_parse.y"
{
#if !SOCKS_CLIENT
      timeout->connect = (size_t)atol(yyvsp[0].string);
#endif /* !SOCKS_CLIENT */
   }
break;
case 99:
#line 715 "config_parse.y"
{
#if !SOCKS_CLIENT
      timeout->tcp_fin_wait = (size_t)atol(yyvsp[0].string);
#endif /* !SOCKS_CLIENT */
   }
break;
case 100:
#line 723 "config_parse.y"
{
#if !SOCKS_CLIENT
      if (sockscf.option.debugrunopt == -1)
#endif /* !SOCKS_CLIENT */
          sockscf.option.debug = atoi(yyvsp[0].string);
   }
break;
case 103:
#line 735 "config_parse.y"
{
#if !SOCKS_CLIENT
#if HAVE_LIBWRAP
      if ((hosts_allow_table = strdup(yyvsp[0].string)) == NULL)
         yyerror(NOMEM);
      slog(LOG_DEBUG, "libwrap.allow: %s", hosts_allow_table);
#else
      yyerror("libwrap.allow requires libwrap library");
#endif /* HAVE_LIBWRAP */
#endif /* !SOCKS_CLIENT */
   }
break;
case 104:
#line 748 "config_parse.y"
{
#if !SOCKS_CLIENT
#if HAVE_LIBWRAP
      if ((hosts_deny_table = strdup(yyvsp[0].string)) == NULL)
         yyerror(NOMEM);
      slog(LOG_DEBUG, "libwrap.deny: %s", hosts_deny_table);
#else
      yyerror("libwrap.deny requires libwrap library");
#endif /* HAVE_LIBWRAP */
#endif /* !SOCKS_CLIENT */
   }
break;
case 105:
#line 761 "config_parse.y"
{
#if !SOCKS_CLIENT
#if HAVE_LIBWRAP
      sockscf.option.hosts_access = 1;
#else
      yyerror("libwrap.hosts_access requires libwrap library");
#endif /* HAVE_LIBWRAP */
   }
break;
case 106:
#line 769 "config_parse.y"
{
#if HAVE_LIBWRAP
      sockscf.option.hosts_access = 0;
#else
      yyerror("libwrap.hosts_access requires libwrap library");
#endif /* HAVE_LIBWRAP */
#endif /* !SOCKS_CLIENT */
   }
break;
case 107:
#line 779 "config_parse.y"
{
#if !SOCKS_CLIENT
      sockscf.udpconnectdst = 1;
   }
break;
case 108:
#line 783 "config_parse.y"
{
      sockscf.udpconnectdst = 0;
#endif /* !SOCKS_CLIENT */
   }
break;
case 110:
#line 793 "config_parse.y"
{
#if !SOCKS_CLIENT
      sockscf.compat.sameport = 1;
   }
break;
case 111:
#line 797 "config_parse.y"
{
      sockscf.compat.draft_5_05 = 1;
#endif /* !SOCKS_CLIENT */
   }
break;
case 115:
#line 810 "config_parse.y"
{
         sockscf.resolveprotocol = RESOLVEPROTOCOL_FAKE;
   }
break;
case 116:
#line 813 "config_parse.y"
{
#if HAVE_NO_RESOLVESTUFF
         yyerror("resolveprotocol keyword not supported on this installation");
#else
         sockscf.resolveprotocol = RESOLVEPROTOCOL_TCP;
#endif /* !HAVE_NO_RESOLVESTUFF */
   }
break;
case 117:
#line 820 "config_parse.y"
{
         sockscf.resolveprotocol = RESOLVEPROTOCOL_UDP;
   }
break;
case 119:
#line 828 "config_parse.y"
{
#if !SOCKS_CLIENT
         sockscf.srchost.nodnsmismatch = 1;
   }
break;
case 120:
#line 832 "config_parse.y"
{
         sockscf.srchost.nodnsunknown = 1;
   }
break;
case 121:
#line 835 "config_parse.y"
{
         sockscf.srchost.checkreplyauth = 1;
#endif /* !SOCKS_CLIENT */
   }
break;
case 124:
#line 845 "config_parse.y"
{
#if COVENANT 
   if (strlen(yyvsp[0].string) >= sizeof(sockscf.realmname))
      yyerror("realmname \"%s\" is too long.  Recompilation of %s required "
              "is required if you want to use a name longer than %d characters",
               yyvsp[0].string, PACKAGE,
               sizeof(sockscf.realmname) - 1);

   strcpy(sockscf.realmname, yyvsp[0].string);
#else /* !COVENANT */
   yyerror("unknown keyword \"%s\"", yyvsp[-2].string);
#endif /* !COVENANT */
}
break;
case 128:
#line 867 "config_parse.y"
{
#if SOCKS_SERVER
      methodv  = sockscf.methodv;
      methodc  = &sockscf.methodc;
      *methodc = 0; /* reset. */
#else
      yyerror("\"clientmethod\" is used for the global method line in %s, "
              "not \"%s\"",
              PACKAGE, yyvsp[-1].string);
#endif /* !SOCKS_SERVER */
   }
break;
case 130:
#line 880 "config_parse.y"
{
#if !SOCKS_CLIENT
   methodv  = sockscf.clientmethodv;
   methodc  = &sockscf.clientmethodc;
   *methodc = 0; /* reset. */
#endif /* !SOCKS_CLIENT */
   }
break;
case 132:
#line 889 "config_parse.y"
{
      ADDMETHOD(AUTHMETHOD_NONE);
   }
break;
case 133:
#line 892 "config_parse.y"
{
#if !HAVE_GSSAPI
      yyerror("method %s requires gssapi library", AUTHMETHOD_GSSAPIs);
#else
      ADDMETHOD(AUTHMETHOD_GSSAPI);
#endif /* !HAVE_GSSAPI */
   }
break;
case 134:
#line 899 "config_parse.y"
{
      ADDMETHOD(AUTHMETHOD_UNAME);
   }
break;
case 135:
#line 902 "config_parse.y"
{
#if HAVE_LIBWRAP
      ADDMETHOD(AUTHMETHOD_RFC931);
#else
      yyerror("method %s requires libwrap library", AUTHMETHOD_RFC931s);
#endif /* HAVE_LIBWRAP */
   }
break;
case 136:
#line 909 "config_parse.y"
{
#if HAVE_PAM
      ADDMETHOD(AUTHMETHOD_PAM);
#else /* !HAVE_PAM */
      yyerror("method %s requires pam library", AUTHMETHOD_PAMs);
#endif /* HAVE_PAM */
   }
break;
case 137:
#line 916 "config_parse.y"
{
#if HAVE_BSDAUTH
      ADDMETHOD(AUTHMETHOD_BSDAUTH);
#else /* !HAVE_PAM */
      yyerror("method %s requires bsd authentication", AUTHMETHOD_BSDAUTHs);
#endif /* HAVE_PAM */
   }
break;
case 138:
#line 929 "config_parse.y"
{

#if !SOCKS_CLIENT
      rule.src         = src;
      rule.dst         = dst;
      rule.rdr_from    = rdr_from;
      rule.rdr_to      = rdr_to;

#if BAREFOOTD
      if (bounce_to.atype == SOCKS_ADDR_NOTSET) {
         if (rule.verdict == VERDICT_PASS)
            yyerror("no address traffic should bounce to has been given");
         else {
            /*
             * allow no bounce-to if it is a block, as the bounce-to address
             * will not be used in any case then.
             */
            bounce_to.atype                 = SOCKS_ADDR_IPV4;
            bounce_to.addr.ipv4.ip.s_addr   = htonl(INADDR_ANY);
            bounce_to.addr.ipv4.mask.s_addr = htonl(0xffffffff);
            bounce_to.port.tcp              = bounce_to.port.udp = htons(0);
            bounce_to.operator              = none;
         }
      }

      rule.bounce_to = bounce_to;
#endif /* BAREFOOTD */

      addclientrule(&rule);

      rulereset();
#endif /* !SOCKS_CLIENT */
   }
break;
case 140:
#line 965 "config_parse.y"
{
#if !SOCKS_CLIENT
         checkmodule("bandwidth");
#endif /* !SOCKS_CLIENT */
   }
break;
case 141:
#line 970 "config_parse.y"
{
#if !BAREFOOTD
         yyerror("unsupported option");
#endif /* !BAREFOOTD */
   }
break;
case 142:
#line 975 "config_parse.y"
{
#if !SOCKS_CLIENT
         checkmodule("redirect");
#endif /* !SOCKS_CLIENT */
   }
break;
case 143:
#line 982 "config_parse.y"
{ yyval.string = NULL; }
break;
case 145:
#line 986 "config_parse.y"
{
#if !SOCKS_CLIENT
      rule.src         = src;
      rule.dst         = dst;
      rule.rdr_from    = rdr_from;
      rule.rdr_to      = rdr_to;

#if !SOCKS_SERVER
   yyerror("socks-rules are not used in %s", PACKAGE);
#endif /* !SOCKS_SERVER */

      addsocksrule(&rule);
      rulereset();
#endif /* !SOCKS_CLIENT */
   }
break;
case 147:
#line 1005 "config_parse.y"
{
#if !SOCKS_CLIENT
         checkmodule("bandwidth");
#endif /* !SOCKS_CLIENT */
   }
break;
case 152:
#line 1014 "config_parse.y"
{
#if !SOCKS_CLIENT
         checkmodule("redirect");
#endif /* !SOCKS_CLIENT */
   }
break;
case 153:
#line 1021 "config_parse.y"
{ yyval.string = NULL; }
break;
case 195:
#line 1065 "config_parse.y"
{
#if !BAREFOOTD
         yyerror("unsupported option");
#endif /* !BAREFOOTD */
   }
break;
case 196:
#line 1070 "config_parse.y"
{
#if !SOCKS_CLIENT
         checkmodule("session");
#endif /* !SOCKS_CLIENT */
   }
break;
case 197:
#line 1077 "config_parse.y"
{
#if SOCKS_SERVER
#if HAVE_LDAP && HAVE_OPENLDAP
      ldap->debug = atoi(yyvsp[0].string);
   }
break;
case 198:
#line 1082 "config_parse.y"
{
      ldap->debug = -atoi(yyvsp[0].string);
 #else /* !HAVE_LDAP */
      yyerror("ldap debug support requires openldap support");
#endif /* !HAVE_LDAP */
#endif /* SOCKS_SERVER */
   }
break;
case 199:
#line 1091 "config_parse.y"
{
#if SOCKS_SERVER
#if HAVE_LDAP
      if (strlen(yyvsp[0].string) >= sizeof(state.ldap.domain))
         yyerror("filter too long");
      strcpy(ldap->domain, yyvsp[0].string);
#else /* !HAVE_LDAP */
      yyerror("no LDAP support configured for %s/server", PACKAGE);
#endif /* !HAVE_LDAP */
#endif /* SOCKS_SERVER */
   }
break;
case 200:
#line 1104 "config_parse.y"
{
#if SOCKS_SERVER
#if HAVE_LDAP && HAVE_OPENLDAP
      ldap->mdepth = atoi(yyvsp[0].string);
#else /* !HAVE_LDAP */
      yyerror("ldap debug support requires openldap support");
#endif /* !HAVE_LDAP */
#endif /* SOCKS_SERVER */
   }
break;
case 201:
#line 1115 "config_parse.y"
{
#if SOCKS_SERVER
#if HAVE_LDAP
      if (strlen(yyvsp[0].string) >= sizeof(state.ldap.certfile))
         yyerror("ca cert file name too long");
      strcpy(ldap->certfile, yyvsp[0].string);
#else /* !HAVE_LDAP */
      yyerror("no LDAP support configured for %s/server", PACKAGE);
#endif /* !HAVE_LDAP */
#endif /* SOCKS_SERVER */
   }
break;
case 202:
#line 1128 "config_parse.y"
{
#if SOCKS_SERVER
#if HAVE_LDAP
      if (strlen(yyvsp[0].string) >= sizeof(state.ldap.certpath))
         yyerror("cert db path too long");
      strcpy(ldap->certpath, yyvsp[0].string);
#else /* !HAVE_LDAP */
      yyerror("no LDAP support configured for %s/server", PACKAGE);
#endif /* !HAVE_LDAP */
#endif /* SOCKS_SERVER */
   }
break;
case 203:
#line 1141 "config_parse.y"
{
#if SOCKS_SERVER
#if HAVE_LDAP
      if (addlinkedname(&rule.state.ldap.ldapurl, yyvsp[0].string) == NULL)
         yyerror(NOMEM);
#else /* !HAVE_LDAP */
      yyerror("no LDAP support configured for %s/server", PACKAGE);
#endif /* !HAVE_LDAP */
#endif /* SOCKS_SERVER */
   }
break;
case 204:
#line 1153 "config_parse.y"
{
#if SOCKS_SERVER
#if HAVE_LDAP
      if (addlinkedname(&rule.state.ldap.ldapbasedn, yyvsp[0].string) == NULL)
         yyerror(NOMEM);
#else /* !HAVE_LDAP */
      yyerror("no LDAP support configured for %s/server", PACKAGE);
#endif /* !HAVE_LDAP */
#endif /* SOCKS_SERVER */
   }
break;
case 205:
#line 1165 "config_parse.y"
{
#if SOCKS_SERVER
#if HAVE_LDAP
      if (addlinkedname(&rule.state.ldap.ldapbasedn, hextoutf8(yyvsp[0].string, 0)) == NULL)
         yyerror(NOMEM);
#else /* !HAVE_LDAP */
      yyerror("no LDAP support configured for %s/server", PACKAGE);
#endif /* !HAVE_LDAP */
#endif /* SOCKS_SERVER */
   }
break;
case 206:
#line 1177 "config_parse.y"
{
#if SOCKS_SERVER
#if HAVE_LDAP
      if (addlinkedname(&rule.state.ldap.ldapbasedn, hextoutf8(yyvsp[0].string, 1)) == NULL)
         yyerror(NOMEM);
#else /* !HAVE_LDAP */
      yyerror("no LDAP support configured for %s/server", PACKAGE);
#endif /* !HAVE_LDAP */
#endif /* SOCKS_SERVER */
   }
break;
case 207:
#line 1189 "config_parse.y"
{
#if SOCKS_SERVER
#if HAVE_LDAP
   ldap->port = atoi(yyvsp[0].string);
#else /* !HAVE_LDAP */
   yyerror("no LDAP support configured for %s/server", PACKAGE);
#endif /* !HAVE_LDAP */
#endif /* SOCKS_SERVER */
   }
break;
case 208:
#line 1200 "config_parse.y"
{
#if SOCKS_SERVER
#if HAVE_LDAP
   ldap->portssl = atoi(yyvsp[0].string);
#else /* !HAVE_LDAP */
   yyerror("no LDAP support configured for %s/server", PACKAGE);
#endif /* !HAVE_LDAP */
#endif /* SOCKS_SERVER */
   }
break;
case 209:
#line 1211 "config_parse.y"
{
#if SOCKS_SERVER
#if HAVE_LDAP
      ldap->ssl = 1;
   }
break;
case 210:
#line 1216 "config_parse.y"
{
      ldap->ssl = 0;
#else /* !HAVE_LDAP */
      yyerror("no LDAP support configured for %s/server", PACKAGE);
#endif /* !HAVE_LDAP */
#endif /* SOCKS_SERVER */
   }
break;
case 211:
#line 1225 "config_parse.y"
{
#if SOCKS_SERVER
#if HAVE_LDAP
      ldap->auto_off = 1;
   }
break;
case 212:
#line 1230 "config_parse.y"
{
      ldap->auto_off = 0;
#else /* !HAVE_LDAP */
      yyerror("no LDAP support configured for %s/server", PACKAGE);
#endif /* !HAVE_LDAP */
#endif /* SOCKS_SERVER */
   }
break;
case 213:
#line 1239 "config_parse.y"
{
#if SOCKS_SERVER
#if HAVE_LDAP
      ldap->certcheck = 1;
   }
break;
case 214:
#line 1244 "config_parse.y"
{
      ldap->certcheck = 0;
#else /* !HAVE_LDAP */
      yyerror("no LDAP support configured for %s/server", PACKAGE);
#endif /* !HAVE_LDAP */
#endif /* SOCKS_SERVER */
   }
break;
case 215:
#line 1253 "config_parse.y"
{
#if SOCKS_SERVER
#if HAVE_LDAP
      ldap->keeprealm = 1;
   }
break;
case 216:
#line 1258 "config_parse.y"
{
      ldap->keeprealm = 0;
#else /* !HAVE_LDAP */
      yyerror("no LDAP support configured for %s/server", PACKAGE);
#endif /* !HAVE_LDAP */
#endif /* SOCKS_SERVER */
   }
break;
case 217:
#line 1267 "config_parse.y"
{
#if SOCKS_SERVER
#if HAVE_LDAP
      if (strlen(yyvsp[0].string) >= sizeof(state.ldap.filter))
         yyerror("filter too long");
      strcpy(ldap->filter, yyvsp[0].string);
#else /* !HAVE_LDAP */
      yyerror("no LDAP support configured for %s/server", PACKAGE);
#endif /* !HAVE_LDAP */
#endif /* SOCKS_SERVER */
   }
break;
case 218:
#line 1280 "config_parse.y"
{
#if SOCKS_SERVER
#if HAVE_LDAP
      if (strlen(yyvsp[0].string) >= sizeof(state.ldap.filter_AD))
         yyerror("AD filter too long");
      strcpy(ldap->filter_AD, yyvsp[0].string);
#else /* !HAVE_LDAP */
      yyerror("no LDAP support configured for %s/server", PACKAGE);
#endif /* !HAVE_LDAP */
#endif /* SOCKS_SERVER */
   }
break;
case 219:
#line 1293 "config_parse.y"
{
#if SOCKS_SERVER
#if HAVE_LDAP
      if (strlen(yyvsp[0].string)/2 >= sizeof(state.ldap.filter))
         yyerror("filter too long");
      strcpy(ldap->filter, hextoutf8(yyvsp[0].string, 2));
#else /* !HAVE_LDAP */
      yyerror("no LDAP support configured for %s/server", PACKAGE);
#endif /* !HAVE_LDAP */
#endif /* SOCKS_SERVER */
   }
break;
case 220:
#line 1306 "config_parse.y"
{
#if SOCKS_SERVER
#if HAVE_LDAP
      if (strlen(yyvsp[0].string)/2 >= sizeof(state.ldap.filter_AD))
         yyerror("AD filter too long");
      strcpy(ldap->filter_AD, hextoutf8(yyvsp[0].string,2));
#else /* !HAVE_LDAP */
      yyerror("no LDAP support configured for %s/server", PACKAGE);
#endif /* !HAVE_LDAP */
#endif /* SOCKS_SERVER */
   }
break;
case 221:
#line 1319 "config_parse.y"
{
#if SOCKS_SERVER
#if HAVE_LDAP
      if (strlen(yyvsp[0].string) >= sizeof(state.ldap.attribute))
         yyerror("attribute too long");
      strcpy(ldap->attribute, yyvsp[0].string);
#else /* !HAVE_LDAP */
      yyerror("no LDAP support configured for %s/server", PACKAGE);
#endif /* !HAVE_LDAP */
#endif /* SOCKS_SERVER */
   }
break;
case 222:
#line 1332 "config_parse.y"
{
#if SOCKS_SERVER
#if HAVE_LDAP
      if (strlen(yyvsp[0].string) >= sizeof(state.ldap.attribute_AD))
         yyerror("AD attribute too long");
      strcpy(ldap->attribute_AD, yyvsp[0].string);
#else /* !HAVE_LDAP */
      yyerror("no LDAP support configured for %s/server", PACKAGE);
#endif /* !HAVE_LDAP */
#endif /* SOCKS_SERVER */
   }
break;
case 223:
#line 1345 "config_parse.y"
{
#if SOCKS_SERVER
#if HAVE_LDAP
      if (strlen(yyvsp[0].string) / 2 >= sizeof(state.ldap.attribute))
         yyerror("attribute too long");
      strcpy(ldap->attribute, hextoutf8(yyvsp[0].string, 2));
#else /* !HAVE_LDAP */
      yyerror("no LDAP support configured for %s/server", PACKAGE);
#endif /* !HAVE_LDAP */
#endif /* SOCKS_SERVER */
   }
break;
case 224:
#line 1358 "config_parse.y"
{
#if SOCKS_SERVER
#if HAVE_LDAP
      if (strlen(yyvsp[0].string) / 2 >= sizeof(state.ldap.attribute_AD))
         yyerror("AD attribute too long");
      strcpy(ldap->attribute_AD, hextoutf8(yyvsp[0].string, 2));
#else /* !HAVE_LDAP */
      yyerror("no LDAP support configured for %s/server", PACKAGE);
#endif /* !HAVE_LDAP */
#endif /* SOCKS_SERVER */
   }
break;
case 225:
#line 1371 "config_parse.y"
{
#if SOCKS_SERVER
#if HAVE_LDAP
      if (addlinkedname(&rule.ldapgroup, hextoutf8(yyvsp[0].string, 0)) == NULL)
         yyerror(NOMEM);
#else /* !HAVE_LDAP */
      yyerror("no LDAP support configured for %s/server", PACKAGE);
#endif /* !HAVE_LDAP */
#endif /* SOCKS_SERVER */
   }
break;
case 226:
#line 1383 "config_parse.y"
{
#if SOCKS_SERVER
#if HAVE_LDAP
      if (addlinkedname(&rule.ldapgroup, hextoutf8(yyvsp[0].string, 1)) == NULL)
         yyerror(NOMEM);
#else /* !HAVE_LDAP */
      yyerror("no LDAP support configured for %s/server", PACKAGE);
#endif /* !HAVE_LDAP */
#endif /* SOCKS_SERVER */
   }
break;
case 227:
#line 1395 "config_parse.y"
{
#if SOCKS_SERVER
#if HAVE_LDAP
      if (addlinkedname(&rule.ldapgroup, asciitoutf8(yyvsp[0].string)) == NULL)
         yyerror(NOMEM);
#else /* !HAVE_LDAP */
      yyerror("no LDAP support configured for %s/server", PACKAGE);
#endif /* !HAVE_LDAP */
#endif /* SOCKS_SERVER */
   }
break;
case 228:
#line 1407 "config_parse.y"
{
#if SOCKS_SERVER
#if HAVE_LDAP
      if (addlinkedname(&rule.ldapserver, yyvsp[0].string) == NULL)
         yyerror(NOMEM);
#else /* !HAVE_LDAP */
      yyerror("no LDAP support configured for %s/server", PACKAGE);
#endif /* !HAVE_LDAP */
#endif /* SOCKS_SERVER */
   }
break;
case 229:
#line 1419 "config_parse.y"
{
#if HAVE_LDAP
#if SOCKS_SERVER
      if (strlen(yyvsp[0].string) >= sizeof(state.ldap.keytab))
         yyerror("keytab name too long");
      strcpy(ldap->keytab, yyvsp[0].string);
#else
      yyerror("ldap keytab only applicable to Dante server");
#endif /* SOCKS_SERVER */
#else
      yyerror("no LDAP support configured for %s/server", PACKAGE);
#endif /* HAVE_LDAP */
   }
break;
case 231:
#line 1437 "config_parse.y"
{
#if HAVE_GSSAPI
      gssapiencryption->nec = 1;
#else
      yyerror("method %s requires gssapi library", AUTHMETHOD_GSSAPIs);
#endif /* HAVE_GSSAPI */
   }
break;
case 234:
#line 1451 "config_parse.y"
{
#if !SOCKS_CLIENT
      ruleinit(&rule);
      rule.verdict   = VERDICT_BLOCK;
   }
break;
case 235:
#line 1456 "config_parse.y"
{
      ruleinit(&rule);
      rule.verdict   = VERDICT_PASS;
#endif /* !SOCKS_CLIENT */
   }
break;
case 239:
#line 1470 "config_parse.y"
{
         command->bind = 1;
   }
break;
case 240:
#line 1473 "config_parse.y"
{
         command->connect = 1;
   }
break;
case 241:
#line 1476 "config_parse.y"
{
         command->udpassociate = 1;
   }
break;
case 242:
#line 1482 "config_parse.y"
{
         command->bindreply = 1;
   }
break;
case 243:
#line 1486 "config_parse.y"
{
         command->udpreply = 1;
   }
break;
case 247:
#line 1499 "config_parse.y"
{
      protocol->tcp = 1;
   }
break;
case 248:
#line 1502 "config_parse.y"
{
      protocol->udp = 1;
   }
break;
case 254:
#line 1519 "config_parse.y"
{
#if !SOCKS_CLIENT
   static shmem_object_t ssinit;

   if (pidismother(sockscf.state.pid) == 1) {
      if ((rule.ss = malloc(sizeof(*rule.ss))) == NULL)
         yyerror("failed to malloc %lu bytes for ss memory",
         (unsigned long)sizeof(*rule.ss));

      *rule.ss = ssinit;

      if (atoi(yyvsp[0].string) < 0)
         yyerror("session value can not be less than 0");
      rule.ss->object.ss.maxsessions = (size_t)atol(yyvsp[0].string);
   }
   else
      rule.ss = &ssinit;

   rule.ss_fd = -1;
#endif /* !SOCKS_CLIENT */
}
break;
case 255:
#line 1542 "config_parse.y"
{
#if !SOCKS_CLIENT
   static shmem_object_t bwmeminit;

   if (pidismother(sockscf.state.pid) == 1) {
      if ((rule.bw = malloc(sizeof(*rule.bw))) == NULL)
         yyerror("failed to malloc %lu bytes for bw memory",
         (unsigned long)sizeof(*rule.bw));

      *rule.bw = bwmeminit;
      if ((rule.bw->object.bw.maxbps = (size_t)atol(yyvsp[0].string)) <= 0)
         yyerror("bandwidth value must be greater than 0");
   }
   else
      rule.bw = &bwmeminit;

   rule.bw_fd = -1;
#endif /* !SOCKS_CLIENT */
}
break;
case 257:
#line 1567 "config_parse.y"
{
#if !SOCKS_CLIENT
   rule.log.connect = 1;
   }
break;
case 258:
#line 1571 "config_parse.y"
{
         rule.log.data = 1;
   }
break;
case 259:
#line 1574 "config_parse.y"
{
         rule.log.disconnect = 1;
   }
break;
case 260:
#line 1577 "config_parse.y"
{
         rule.log.error = 1;
   }
break;
case 261:
#line 1580 "config_parse.y"
{
         rule.log.iooperation = 1;
#endif /* !SOCKS_CLIENT */
   }
break;
case 264:
#line 1591 "config_parse.y"
{
#if HAVE_PAM && (!SOCKS_CLIENT)
      if (strlen(yyvsp[0].string) >= sizeof(rule.state.pamservicename))
         yyerror("servicename too long");
      strcpy(rule.state.pamservicename, yyvsp[0].string);
#else
      yyerror("pam support not compiled in");
#endif /* HAVE_PAM && (!SOCKS_CLIENT) */
   }
break;
case 265:
#line 1602 "config_parse.y"
{
#if HAVE_BSDAUTH && SOCKS_SERVER
      if (strlen(yyvsp[0].string) >= sizeof(rule.state.bsdauthstylename))
         yyerror("bsdauthstyle too long");
      strcpy(rule.state.bsdauthstylename, yyvsp[0].string);
#else
      yyerror("bsdauth support not compiled in");
#endif /* HAVE_BSDAUTH && SOCKS_SERVER */
   }
break;
case 266:
#line 1614 "config_parse.y"
{
#if HAVE_GSSAPI
      if (strlen(yyvsp[0].string) >= sizeof(state.gssapiservicename))
         yyerror("service name too long");
      strcpy(gssapiservicename, yyvsp[0].string);
#else
      yyerror("gssapi support not compiled in");
#endif /* HAVE_GSSAPI */
   }
break;
case 267:
#line 1625 "config_parse.y"
{
#if HAVE_GSSAPI
#if SOCKS_SERVER
      if (strlen(yyvsp[0].string) >= sizeof(state.gssapikeytab))
         yyerror("keytab name too long");
      strcpy(gssapikeytab, yyvsp[0].string);
#else
      yyerror("gssapi keytab only applicable to Dante server");
#endif /* SOCKS_SERVER */
#else
      yyerror("gssapi support not compiled in");
#endif /* HAVE_GSSAPI */
   }
break;
case 269:
#line 1643 "config_parse.y"
{
#if HAVE_GSSAPI
      gssapiencryption->clear           = 1;
      gssapiencryption->integrity       = 1;
      gssapiencryption->confidentiality = 1;
   }
break;
case 270:
#line 1649 "config_parse.y"
{
      gssapiencryption->clear = 1;
   }
break;
case 271:
#line 1652 "config_parse.y"
{
      gssapiencryption->integrity = 1;
   }
break;
case 272:
#line 1655 "config_parse.y"
{
      gssapiencryption->confidentiality = 1;
   }
break;
case 273:
#line 1658 "config_parse.y"
{
      yyerror("gssapi per-message encryption not supported");
#else
      yyerror("gssapi support not compiled in");
#endif /* HAVE_GSSAPI */
   }
break;
case 277:
#line 1673 "config_parse.y"
{
#if HAVE_LIBWRAP && (!SOCKS_CLIENT)
      struct request_info request;
      char libwrap[LIBWRAPBUF];

      if (strlen(yyvsp[0].string) >= sizeof(rule.libwrap))
         yyerror("libwrapline too long, make LIBWRAPBUF bigger");
      strcpy(rule.libwrap, yyvsp[0].string);

      /* libwrap modifies the passed buffer. */
      SASSERTX(strlen(rule.libwrap) < sizeof(libwrap));
      strcpy(libwrap, rule.libwrap);

      ++dry_run;
      request_init(&request, RQ_FILE, -1, RQ_DAEMON, __progname, 0);
      if (setjmp(tcpd_buf) != 0)
         yyerror("bad libwrap line");
      process_options(libwrap, &request);
      --dry_run;

#else
      yyerror("libwrap support not compiled in");
#endif /* HAVE_LIBWRAP && (!SOCKS_CLIENT) */
   }
break;
case 292:
#line 1727 "config_parse.y"
{ yyval.string = NULL; }
break;
case 294:
#line 1731 "config_parse.y"
{
      addrinit(&src, 1);
   }
break;
case 295:
#line 1736 "config_parse.y"
{
      addrinit(&dst, 
#if SOCKS_SERVER
               1
#else /* BAREFOOT || COVENANT */
               0 /* the address the server should bind, so must be /32. */
#endif /*  BAREFOOT || COVENANT */
      );
   }
break;
case 296:
#line 1747 "config_parse.y"
{
      addrinit(&rdr_from, 1);
   }
break;
case 297:
#line 1752 "config_parse.y"
{
      addrinit(&rdr_to, 1);
   }
break;
case 298:
#line 1757 "config_parse.y"
{
#if BAREFOOTD
      addrinit(&bounce_to, 0);
#endif /* BAREFOOTD */
   }
break;
case 299:
#line 1765 "config_parse.y"
{
      gwaddrinit(&gw);
   }
break;
case 304:
#line 1777 "config_parse.y"
{ 
         if (netmask_required)
            yyerror("no netmask given");
         else
            netmask->s_addr = htonl(0xffffffff);
       }
break;
case 313:
#line 1795 "config_parse.y"
{
      *atype = SOCKS_ADDR_IPV4;

      if (inet_aton(yyvsp[0].string, ipaddr) != 1)
         yyerror("bad address: %s", yyvsp[0].string);
   }
break;
case 314:
#line 1804 "config_parse.y"
{
      if (atoi(yyvsp[0].string) < 0 || atoi(yyvsp[0].string) > 32)
         yyerror("bad netmask: %s", yyvsp[0].string);

      netmask->s_addr
      = atoi(yyvsp[0].string) == 0 ? 0 : htonl(0xffffffff << (32 - atoi(yyvsp[0].string)));
   }
break;
case 315:
#line 1811 "config_parse.y"
{
         if (!inet_aton(yyvsp[0].string, netmask))
            yyerror("bad netmask: %s", yyvsp[0].string);
   }
break;
case 316:
#line 1817 "config_parse.y"
{
      *atype = SOCKS_ADDR_DOMAIN;

      if (strlen(yyvsp[0].string) >= MAXHOSTNAMELEN)
         yyerror("domainname too long");

      strcpy(domain, yyvsp[0].string);
   }
break;
case 317:
#line 1827 "config_parse.y"
{
      *atype = SOCKS_ADDR_IFNAME;

      if (strlen(yyvsp[0].string) >= MAXIFNAMELEN)
         yyerror("interface name too long");

      strcpy(ifname, yyvsp[0].string);
   }
break;
case 318:
#line 1838 "config_parse.y"
{
      *atype = SOCKS_ADDR_DOMAIN;

      if (strlen(yyvsp[0].string) >= MAXHOSTNAMELEN)
         yyerror("domain name \"%s\" too long", yyvsp[0].string);
      strcpy(domain, yyvsp[0].string);

      proxyprotocol->direct = 1;
   }
break;
case 319:
#line 1849 "config_parse.y"
{
      *atype = SOCKS_ADDR_URL;

      if (strlen(yyvsp[0].string) >= MAXURLLEN)
         yyerror("url \"%s\" too long", yyvsp[0].string);

      strcpy(url, yyvsp[0].string);
   }
break;
case 320:
#line 1860 "config_parse.y"
{ yyval.string = NULL; }
break;
case 324:
#line 1866 "config_parse.y"
{ yyval.string = NULL; }
break;
case 328:
#line 1874 "config_parse.y"
{
   if (ntohs(*port_tcp) > ntohs(ruleaddr->portend))
      yyerror("end port (%u) can not be less than start port (%u)",
      ntohs(*port_tcp), ntohs(ruleaddr->portend));
   }
break;
case 329:
#line 1882 "config_parse.y"
{
      *port_tcp   = htons((in_port_t)atoi(yyvsp[0].string));
      *port_udp   = htons((in_port_t)atoi(yyvsp[0].string));
   }
break;
case 330:
#line 1888 "config_parse.y"
{
      ruleaddr->portend    = htons((in_port_t)atoi(yyvsp[0].string));
      ruleaddr->operator   = range;
   }
break;
case 331:
#line 1894 "config_parse.y"
{
      struct servent   *service;

      if ((service = getservbyname(yyvsp[0].string, "tcp")) == NULL) {
         if (protocol->tcp)
            yyerror("unknown tcp protocol: %s", yyvsp[0].string);
         *port_tcp = htons(0);
      }
      else
         *port_tcp = (in_port_t)service->s_port;

      if ((service = getservbyname(yyvsp[0].string, "udp")) == NULL) {
         if (protocol->udp)
               yyerror("unknown udp protocol: %s", yyvsp[0].string);
            *port_udp = htons(0);
      }
      else
         *port_udp = (in_port_t)service->s_port;

      if (*port_tcp == htons(0) && *port_udp == htons(0))
         yyerror("unknown tcp/udp protocol");

      /* if one protocol is unset, set to same as the other. */
      if (*port_tcp == htons(0))
         *port_tcp = *port_udp;
      else if (*port_udp == htons(0))
         *port_udp = *port_tcp;
   }
break;
case 332:
#line 1925 "config_parse.y"
{
      *operator = string2operator(yyvsp[0].string);
   }
break;
case 334:
#line 1933 "config_parse.y"
{
#if SOCKS_SERVER
   rule.udprange.start = htons((in_port_t)atoi(yyvsp[0].string));
#endif /* SOCKS_SERVER */
   }
break;
case 335:
#line 1940 "config_parse.y"
{
#if SOCKS_SERVER
   rule.udprange.end = htons((in_port_t)atoi(yyvsp[0].string));
   rule.udprange.op  = range;

   if (ntohs(rule.udprange.start) > ntohs(rule.udprange.end))
      yyerror("udp end port (%s) can not be less than udp start port (%u)",
      yyvsp[0].string, ntohs(rule.udprange.start));
#endif /* SOCKS_SERVER */
   }
break;
#line 3741 "config_parse.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yyssp, yystate);
#endif
    if (yyssp >= yysslim && yygrowstack())
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    if (yyss)
            free(yyss);
    if (yyvs)
            free(yyvs);
    yyss = yyssp = NULL;
    yyvs = yyvsp = NULL;
    yystacksize = 0;
    return (1);
yyaccept:
    if (yyss)
            free(yyss);
    if (yyvs)
            free(yyvs);
    yyss = yyssp = NULL;
    yyvs = yyvsp = NULL;
    yystacksize = 0;
    return (0);
}
